Attribute VB_Name = "basCalc"
Option Explicit

Private Declare Function aa_check_date Lib "acalz" (ByRef piMonth As Long, ByRef piWWeek As Long, piDWeek As Long, ByRef piDays As Long, ByRef piHour As Long, ByVal psChkLine As String, ByVal psStartDate As String, ByVal psEndDate As String, ByVal plDateCheck As Long) As Long
Private Declare Function aa_get_analize_line Lib "acalz" (ByVal psFileName As String, ByVal plMaxBuff As Long) As Long

' p[^L[
Private Const csOsString        As String = "OS"
Private Const csBrwsString      As String = "Browser"
Private Const csIgnoreString    As String = "IgnoreIndex"
Private Const csIgnoreHost      As String = "IgnoreHost"
Private Const csGifFileName     As String = "bar.gif"
Private Const ciMaxHtmlValue    As Integer = 500

Public Enum eiCalcId
    elAccessNum

    elMonthAccess
    elWWeekAccess
    elDWeekAccess
    elDateAccess
    elTimeAccess

    elOsStrNum
    elOsAccess
    elOsFindStr
    elOsString

    elBrwsStrNum
    elBrwsAccess
    elBrwsFindStr
    elBrwsString

    elAgentStrNum
    elAgentAccess
    elAgentString

    elHostStrNum
    elHostAccess
    elHostString

    elRefStrNum
    elRefAccess
    elRefString

    elRefTrueStrNum
    elRefTrueAccess
    elRefTrueString

    elPageStrNum
    elPageAccess
    elPageString

    elIgnoreHostNum
    elIgnoreHost
End Enum

Private Const clNoneAnalize     As Long = 0
Private Const clAnalizeTarget   As Long = 1
Private Const clPageTarget      As Long = 2

Private mlAccessNum             As Long         ' SANZX
Private mlMonthAccess(12)       As Long         ' ʂ̃ANZX
Private mlWWeekAccess(54)       As Long         ' Tʂ̃ANZX
Private mlDWeekAccess(7)        As Long         ' jʂ̃ANZX
Private mlDateAccess(31)        As Long         ' tʂ̃ANZX
Private mlTimeAccess(24)        As Long         ' ԕʂ̃ANZX

Private mlOsStrNum              As Long         ' nr̕
Private mlOsAccess()            As Long         ' nrʂ̃ANZX
Private msOsFindStr()           As String       ' nr̕ipj
Private msOsString()            As String       ' nr̕i\pj
Private msOsOrgString()         As String       ' nr̕i\pj

Private mlBrwsStrNum            As Long         ' uEU̕
Private mlBrwsAccess()          As Long         ' uEUʂ̃ANZX
Private msBrwsFindStr()         As String       ' uEU̕ipj
Private msBrwsString()          As String       ' uEU̕i\pj
Private msBrwsOrgString()       As String       ' uEU̕i\pj

Private mlAgentStrNum           As Long         ' G[WFgf[^̕
Private mlAgentAccess()         As Long         ' G[WFgf[^ʂ̃ANZX
Private msAgentString()         As String       ' G[WFgf[^̕

Private mlHostStrNum            As Long         ' zXg̕
Private mlHostAccess()          As Long         ' zXgʂ̃ANZX
Private msHostString()          As String       ' zXg̕

Private mlRefStrNum             As Long         ' Oʕʂ̕
Private mlRefAccess()           As Long         ' Oʕʕʂ̃ANZX
Private msRefString()           As String       ' Oʕʂ̕

Private mlRefTrueStrNum         As Long         ' Oʕʂ̕񐔁iS`j
Private mlRefTrueAccess()       As Long         ' Oʕʕʂ̃ANZXiS`j
Private msRefTrueString()       As String       ' Oʕʂ̕iS`j

Private mlPageStrNum            As Long         ' y[Wʂ̕
Private mlPageAccess()          As Long         ' y[Wʕʂ̃ANZX
Private msPageString()          As String       ' y[Wʂ̕

Private mlIgnoreIndexNum        As Long         ' CfbNX
Private msIgnoreIndex()         As String       ' CfbNX

Private mlIgnoreHostNum         As Long         ' ͑Ώۂ̃zXg
Private msIgnoreHost()          As String       ' ͑Ώۂ̃zXg

' vZꎞޔpϐ
Private mlMonthTemp             As Long         ' 
Private mlWWeekTemp             As Long         ' T
Private mlDWeekTemp             As Long         ' j
Private mlDaysTemp              As Long         ' 
Private mlHourTemp              As Long         ' 
Private mlOsTemp                As Long         ' nr
Private mlBrwsTemp              As Long         ' uEU
Private mlAgentTemp             As Long         ' G[WFgf[^
Private mlRegTemp               As Long         ' O
Private mlRefTrueTemp           As Long         ' OʁiS`j
Private mlPageTemp              As Long         ' y[W

Private mlReadLine              As Long         ' ͒̍s

Public Property Get aaCalcValue(ByVal piParamKey As Integer, Optional ByVal plIndex As Long) As Variant
'---------------------------------------------------------------------------
'    : aaCalcValue()
' @@@\ : p[^l̎擾
' @@ : (I) piParamKey     p[^hc
'          : (I) plIndex        zԍ
'   l : p[^l
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Select Case piParamKey
    Case elAccessNum
        aaCalcValue = mlAccessNum

    Case elMonthAccess
        aaCalcValue = mlMonthAccess(plIndex)
    Case elWWeekAccess
        aaCalcValue = mlWWeekAccess(plIndex)
    Case elDWeekAccess
        aaCalcValue = mlDWeekAccess(plIndex)
    Case elDateAccess
        aaCalcValue = mlDateAccess(plIndex)
    Case elTimeAccess
        aaCalcValue = mlTimeAccess(plIndex)

    Case elOsStrNum
        aaCalcValue = mlOsStrNum
    Case elOsAccess
        aaCalcValue = mlOsAccess(plIndex)
'    Case elOsFindStr
'        aaCalcValue = msOsFindStr(plIndex)
    Case elOsString
        aaCalcValue = msOsString(plIndex)

    Case elBrwsStrNum
        aaCalcValue = mlBrwsStrNum
    Case elBrwsAccess
        aaCalcValue = mlBrwsAccess(plIndex)
'    Case elBrwsFindStr
'        aaCalcValue = msBrwsFindStr(plIndex)
    Case elBrwsString
        aaCalcValue = msBrwsString(plIndex)

    Case elAgentStrNum
        aaCalcValue = mlAgentStrNum
    Case elAgentAccess
        aaCalcValue = mlAgentAccess(plIndex)
    Case elAgentString
        aaCalcValue = msAgentString(plIndex)

    Case elHostStrNum
        aaCalcValue = mlHostStrNum
    Case elHostAccess
        aaCalcValue = mlHostAccess(plIndex)
    Case elHostString
        aaCalcValue = msHostString(plIndex)

    Case elRefStrNum
        aaCalcValue = mlRefStrNum
    Case elRefAccess
        aaCalcValue = mlRefAccess(plIndex)
    Case elRefString
        aaCalcValue = msRefString(plIndex)

    Case elRefTrueStrNum
        aaCalcValue = mlRefTrueStrNum
    Case elRefTrueAccess
        aaCalcValue = mlRefTrueAccess(plIndex)
    Case elRefTrueString
        aaCalcValue = msRefTrueString(plIndex)

    Case elPageStrNum
        aaCalcValue = mlPageStrNum
    Case elPageAccess
        aaCalcValue = mlPageAccess(plIndex)
    Case elPageString
        aaCalcValue = msPageString(plIndex)

    Case elIgnoreHostNum
        aaCalcValue = mlIgnoreHostNum
    Case elIgnoreHost
        aaCalcValue = msIgnoreHost(plIndex)
    End Select
End Property

Public Sub aaReadFixedInfo()
'---------------------------------------------------------------------------
'    : aaReadFixedInfo()
' @@@\ : Œt@C̓ǂݍ
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/12/20
'---------------------------------------------------------------------------
    Dim llLoopCnt           As Long         ' [vJE^
    Dim liFileNo            As Integer      ' t@Cԍ
    Dim lsFileName          As String       ' t@C
    Dim lsLine              As String       ' ǂݍݕ
    Dim lsKeyStr            As String       ' p[^L[
    Dim liEqlPos            As Integer      ' ̈ʒu
    Dim lsPrmStr            As String       ' p[^l
    Dim lvValues            As Variant      ' ݒl
    Dim lsAppPath           As String       ' AvP[ṼpX

    On Error GoTo ptReadDatFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".dat"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".dat"
    End If
    liFileNo = FreeFile

    mlOsStrNum = 0
    mlBrwsStrNum = 0

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Trim(Left$(lsLine, liEqlPos - 1))
            lsPrmStr = Mid$(lsLine, liEqlPos + 1)

            Select Case UCase(lsKeyStr)
            Case UCase(csOsString)
                liEqlPos = InStr(lsPrmStr, ",")
                If liEqlPos > 0 Then
                    mlOsStrNum = mlOsStrNum + 1
                    ReDim Preserve msOsFindStr(mlOsStrNum)
                    ReDim Preserve msOsString(mlOsStrNum)
                    msOsFindStr(mlOsStrNum) = Left$(lsPrmStr, liEqlPos - 1)
                    msOsString(mlOsStrNum) = Mid$(lsPrmStr, liEqlPos + 1)
                End If

            Case UCase(csBrwsString)
                liEqlPos = InStr(lsPrmStr, ",")
                If liEqlPos > 0 Then
                    mlBrwsStrNum = mlBrwsStrNum + 1
                    ReDim Preserve msBrwsFindStr(mlBrwsStrNum)
                    ReDim Preserve msBrwsString(mlBrwsStrNum)
                    msBrwsFindStr(mlBrwsStrNum) = Left$(lsPrmStr, liEqlPos - 1)
                    msBrwsString(mlBrwsStrNum) = Mid$(lsPrmStr, liEqlPos + 1)
                End If

            Case UCase(csIgnoreString)
                mlIgnoreIndexNum = mlIgnoreIndexNum + 1
                ReDim Preserve msIgnoreIndex(mlIgnoreIndexNum)
                msIgnoreIndex(mlIgnoreIndexNum) = LCase(Trim(lsPrmStr))

            Case UCase(csIgnoreHost)
                mlIgnoreHostNum = mlIgnoreHostNum + 1
                ReDim Preserve msIgnoreHost(mlIgnoreHostNum)
                msIgnoreHost(mlIgnoreHostNum) = LCase(Trim(lsPrmStr))
            End Select
        End If
    Loop
    Close liFileNo

    ReDim msOsOrgString(mlOsStrNum)
    For llLoopCnt = 1 To mlOsStrNum
        msOsOrgString(llLoopCnt) = msOsString(llLoopCnt)
    Next llLoopCnt
    ReDim mlOsAccess(mlOsStrNum)

    ReDim msBrwsOrgString(mlBrwsStrNum)
    For llLoopCnt = 1 To mlBrwsStrNum
        msBrwsOrgString(llLoopCnt) = msBrwsString(llLoopCnt)
    Next llLoopCnt
    ReDim mlBrwsAccess(mlBrwsStrNum)
    Exit Sub

ptReadDatFile_Error:
    MsgBox "͏t@C̓ǂݍ݂Ɏs܂B" & vbCrLf & lsFileName, vbCritical, "G["
    Close liFileNo
End Sub

Public Function aaAccessAnalyze(ByVal piInitFlag As Integer) As Boolean
'---------------------------------------------------------------------------
'    : aaAccessAnalyze()
' @@@\ : ANZXO
' @@ : (I) piInitFlag     tO
'   l : True= I, False= ُI
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim liCalc          As Integer      ' ͑ΏۃtO
    Dim liAllTarget     As Integer      ' ͑ΏۃtO
    Dim lsLine          As String       ' ǂݍݍs
    Dim lsCheckStr      As String       ' `FbN镶
    Dim llAnalyzeLine   As Long         ' ͒̍s
    Dim liCheckLine     As Integer      ' `FbNs

    On Error GoTo aaAccessAnalyze_Error

    liFileNo = FreeFile
'    Open basParam.aaParamValue(csLogFile, 1) For Input Access Read As liFileNo
    Open basParam.aaParamValue(csLogFile, 1) For Binary Access Read As liFileNo

    liCalc = 0
    If piInitFlag = 0 Then
        aaInitAnalize
        mlPageStrNum = 0
        Erase mlPageAccess
        Erase msPageString
    Else
        aaAddAnalize
    End If

    mlReadLine = 0
    liCheckLine = basParam.aaParamValue(csCheckLine)
    liAllTarget = (clAnalizeTarget Or clPageTarget)
    Do While aaReadLogFile(lsLine, liFileNo) <> False
'        lbRetCode = aaReadLogFile(lsLine, liFileNo)
'        Line Input #liFileNo, lsLine
            llAnalyzeLine = llAnalyzeLine + 1
            If (llAnalyzeLine Mod liCheckLine) = 0 Then
                frmStatus.aauStatusChange (llAnalyzeLine \ liCheckLine)
            End If
            lsCheckStr = Left$(lsLine, 2)

            ' t^
            If lsCheckStr = "1#" Then
                mlMonthTemp = -1
                mlWWeekTemp = -1
                mlDWeekTemp = -1
                mlDaysTemp = -1
                mlHourTemp = -1
                mlOsTemp = -1
                mlBrwsTemp = -1
                mlAgentTemp = -1
                mlRegTemp = -1
                mlRefTrueTemp = -1
                mlPageTemp = -1
                liCalc = aaCheckDate(lsLine)

            ' nr^uEU
            ElseIf lsCheckStr = "2#" Then
                If (liCalc And liAllTarget) = liAllTarget Then
                    aaCheckOsBrws lsLine
                End If

            ' O
            ElseIf lsCheckStr = "3#" Then
                If (liCalc And liAllTarget) = liAllTarget Then
                    aaCheckRef lsLine
                End If

            ' zXg^ho
            ElseIf lsCheckStr = "4#" Then
                If (liCalc And clAnalizeTarget) <> 0 Then
                    liCalc = liCalc - clAnalizeTarget
                    liCalc = liCalc Or aaCheckHostIp(lsLine)
                    If (liCalc And liAllTarget) = liAllTarget Then
                        If mlMonthTemp >= 0 Then
                            mlAccessNum = mlAccessNum + 1
                            mlMonthAccess(mlMonthTemp) = mlMonthAccess(mlMonthTemp) + 1
                            mlWWeekAccess(mlWWeekTemp) = mlWWeekAccess(mlWWeekTemp) + 1
                            mlDWeekAccess(mlDWeekTemp) = mlDWeekAccess(mlDWeekTemp) + 1
                            mlDateAccess(mlDaysTemp) = mlDateAccess(mlDaysTemp) + 1
                            mlTimeAccess(mlHourTemp) = mlTimeAccess(mlHourTemp) + 1
                        End If
                        If mlOsTemp >= 0 Then
                            mlOsAccess(mlOsTemp) = mlOsAccess(mlOsTemp) + 1
                        End If
                        If mlBrwsTemp >= 0 Then
                            mlBrwsAccess(mlBrwsTemp) = mlBrwsAccess(mlBrwsTemp) + 1
                        End If
                        If mlAgentTemp >= 0 Then
                            mlAgentAccess(mlAgentTemp) = mlAgentAccess(mlAgentTemp) + 1
                        End If
                        If mlRegTemp >= 0 Then
                            mlRefAccess(mlRegTemp) = mlRefAccess(mlRegTemp) + 1
                        End If
                        If mlRefTrueTemp >= 0 Then
                            mlRefTrueAccess(mlRefTrueTemp) = mlRefTrueAccess(mlRefTrueTemp) + 1
                        End If
                    End If
                End If

                If basParam.aaParamValue(csIgnorePage) = True Or (liCalc And clAnalizeTarget) <> 0 Then
                    If mlPageTemp >= 0 Then
                        mlPageAccess(mlPageTemp) = mlPageAccess(mlPageTemp) + 1
                    End If
                End If
            End If
    Loop

    frmStatus.aauMessageChange "f[^̃\[głB"
    aaJointAccess mlOsAccess, msOsString, 1, mlOsStrNum
    aaJointAccess mlBrwsAccess, msBrwsString, 1, mlBrwsStrNum

    aaSortAccess mlOsAccess, msOsString, 1, mlOsStrNum
    aaSortAccess mlBrwsAccess, msBrwsString, 1, mlBrwsStrNum
    aaSortAccess mlAgentAccess, msAgentString, 1, mlAgentStrNum
    aaSortAccess mlRefAccess, msRefString, 1, mlRefStrNum
    aaSortAccess mlRefTrueAccess, msRefTrueString, 1, mlRefTrueStrNum
    aaSortAccess mlHostAccess, msHostString, 1, mlHostStrNum
    aaSortAccess mlPageAccess, msPageString, 1, mlPageStrNum

    Close #liFileNo
    aaAccessAnalyze = True
    Exit Function

aaAccessAnalyze_Error:
    Close #liFileNo
    MsgBox mlReadLine & "sڂŃG[܂" & vbCrLf & "( " & Err.Description & " )", vbCritical, "̓G["
    aaAccessAnalyze = False
End Function

Public Function aaGetAnalyzeLine() As Long
'---------------------------------------------------------------------------
'    : aaGetAnalyzeLine()
' @@@\ : ANZXO̍s擾
' @@ : Ȃ
'   l : ANZXO̍s
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim lsLine          As String       ' ǂݍݍs
    Dim llAnalyzeLine   As Long         ' ͂s

'    On Error GoTo aaGetAnalyzeLine_Error
'
'    If basParam.aaParamValue(csShareWare) = False Then
'        liFileNo = FreeFile
'        Open basParam.aaParamValue(csLogFile, 1) For Binary Access Read As liFileNo
'
'        Do While aaReadLogFile(lsLine, liFileNo) <> False
'            llAnalyzeLine = llAnalyzeLine + 1
'        Loop
'
'        Close #liFileNo
'        aaGetAnalyzeLine = llAnalyzeLine
'    Else
        On Error GoTo aaGetAnalyzeLineDll_Error
        aaGetAnalyzeLine = aa_get_analize_line(basParam.aaParamValue(csLogFile, 1), 10000)
'    End If
    Exit Function

aaGetAnalyzeLine_Error:
    Close #liFileNo
    aaGetAnalyzeLine = 0
    Exit Function

aaGetAnalyzeLineDll_Error:
    aaGetAnalyzeLine = -1
End Function

Private Function aaReadLogFile(ByRef psLine As String, ByVal piFileNo As Integer) As Boolean
'---------------------------------------------------------------------------
'    : aaReadLogFile()
' @@@\ : ANZXOt@C̓ǂݍ
' @@ : (O) psLine         ǂݍݓe
'   l : True= I, False= ُI
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Static lsLine       As String           ' ǂݍݕ
    Dim llCurPos        As Long             ' ǂݍ݈ʒu
    Dim llTabPos        As Long             ' ^üʒu
    Dim lsFileName      As String           ' t@C
    Dim lsReadLine      As String * 100     ' ǂݍ݃obt@

    aaReadLogFile = True
    psLine = ""

    On Error Resume Next
    If InStr(lsLine, vbLf) = 0 Then
        If EOF(piFileNo) Then
            aaReadLogFile = False
            lsLine = ""
        Else
            Do While Not EOF(piFileNo)
                Get piFileNo, , lsReadLine
                lsLine = lsLine & lsReadLine
                llCurPos = InStr(lsLine, vbLf)
                If llCurPos <> 0 Then
                    Exit Do
                End If
            Loop
        End If
    End If

    If aaReadLogFile <> False Then
        mlReadLine = mlReadLine + 1
        llTabPos = InStr(lsLine, vbTab)
        llCurPos = InStr(lsLine, vbLf)
        If llTabPos < llCurPos Then
            If llTabPos <> 0 Then
                mlReadLine = mlReadLine - 1
                llCurPos = llTabPos
            End If
        End If
        If llCurPos < 1 Then
            psLine = lsLine
        Else
            psLine = Left(lsLine, llCurPos - 1)
            If Right(psLine, 1) = vbCr Then
                psLine = Left(psLine, Len(psLine) - 1)
            End If
        End If

        lsLine = Right(lsLine, Len(lsLine) - llCurPos)
    End If

    Exit Function

aaReadLogFile_Error:
    aaReadLogFile = False
End Function

Public Sub aaInitAnalize()
'---------------------------------------------------------------------------
'    : aaInitAnalize()
' @@@\ : ͏̏
' @@ : Ȃ
'   l : Ȃ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Integer      ' [vJE^

    mlAccessNum = 0
    For llLoopCnt = 0 To 12
        mlMonthAccess(llLoopCnt) = 0
    Next llLoopCnt
    For llLoopCnt = 0 To 54
        mlWWeekAccess(llLoopCnt) = 0
    Next llLoopCnt
    For llLoopCnt = 0 To 7
        mlDWeekAccess(llLoopCnt) = 0
    Next llLoopCnt
    For llLoopCnt = 0 To 31
        mlDateAccess(llLoopCnt) = 0
    Next llLoopCnt
    For llLoopCnt = 0 To 24
        mlTimeAccess(llLoopCnt) = 0
    Next llLoopCnt

    ReDim msOsString(mlOsStrNum)
    For llLoopCnt = 1 To mlOsStrNum
        msOsString(llLoopCnt) = msOsOrgString(llLoopCnt)
    Next llLoopCnt
    ReDim mlOsAccess(mlOsStrNum)

    ReDim msBrwsString(mlBrwsStrNum)
    For llLoopCnt = 1 To mlBrwsStrNum
        msBrwsString(llLoopCnt) = msBrwsOrgString(llLoopCnt)
    Next llLoopCnt
    ReDim mlBrwsAccess(mlBrwsStrNum)

    mlAgentStrNum = 0
    Erase mlAgentAccess
    Erase msAgentString

    mlHostStrNum = 0
    Erase mlHostAccess

    mlRefStrNum = 0
    Erase mlRefAccess
    Erase msRefString

    mlRefTrueStrNum = 0
    Erase mlRefTrueAccess
    Erase msRefTrueString
End Sub

Public Sub aaAddAnalize()
'---------------------------------------------------------------------------
'    : aaAddAnalize()
' @@@\ : ͏̏iǉ͗pj
' @@ : Ȃ
'   l : Ȃ
' @@ : 2000/02/29
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Integer      ' [vJE^
    Dim llSubCnt        As Integer      ' [vJE^
    Dim llTempAccess()  As Long         ' ANZX

    ' nrʃANZX
    ReDim llTempAccess(mlOsStrNum)
    For llLoopCnt = 1 To mlOsStrNum
        llTempAccess(llLoopCnt) = mlOsAccess(llLoopCnt)
        mlOsAccess(llLoopCnt) = 0
    Next llLoopCnt
    For llLoopCnt = 1 To mlOsStrNum
        If llTempAccess(llLoopCnt) <> 0 Then
            For llSubCnt = 1 To mlOsStrNum
                If msOsString(llLoopCnt) = msOsOrgString(llSubCnt) Then
                    mlOsAccess(llSubCnt) = llTempAccess(llLoopCnt)
                    Exit For
                End If
            Next llSubCnt
       End If
    Next llLoopCnt
    ReDim msOsString(mlOsStrNum)
    For llLoopCnt = 1 To mlOsStrNum
        msOsString(llLoopCnt) = msOsOrgString(llLoopCnt)
    Next llLoopCnt

    ' uEUʃANZX
    ReDim llTempAccess(mlBrwsStrNum)
    For llLoopCnt = 1 To mlBrwsStrNum
        llTempAccess(llLoopCnt) = mlBrwsAccess(llLoopCnt)
        mlBrwsAccess(llLoopCnt) = 0
    Next llLoopCnt
    For llLoopCnt = 1 To mlBrwsStrNum
        If llTempAccess(llLoopCnt) <> 0 Then
            For llSubCnt = 1 To mlBrwsStrNum
                If msBrwsString(llLoopCnt) = msBrwsOrgString(llSubCnt) Then
                    mlBrwsAccess(llSubCnt) = llTempAccess(llLoopCnt)
                    Exit For
                End If
            Next llSubCnt
        End If
    Next llLoopCnt
    ReDim msBrwsString(mlBrwsStrNum)
    For llLoopCnt = 1 To mlBrwsStrNum
        msBrwsString(llLoopCnt) = msBrwsOrgString(llLoopCnt)
    Next llLoopCnt

    Erase llTempAccess
End Sub

Private Function aaCheckDate(ByVal psChkLine As String) As Integer
'---------------------------------------------------------------------------
'    : aaCheckDate()
' @@@\ : t̃`FbN
' @@ : (I) psChkLine      `FbNs
'   l : True= Ώ, False= Ώ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim ldAccessDate    As Date         ' ANZXt
    Dim ldStartDate     As Date         ' Jnt
    Dim ldEndDate       As Date         ' It
    Dim lsStartDate     As String       ' Jnt
    Dim lsEndDate       As String       ' It
    Dim liSpacePos      As Integer      ' ؂ʒu
    Dim lsChkPage       As String       ' ̓y[W
    Dim llRet           As Long         ' ߂l
    Dim lsWorkLine      As String       ' ckknp

    aaCheckDate = 0

    lsChkPage = Mid$(psChkLine, 4, InStr(psChkLine, ")") - 4)
    For liLoopCnt = 1 To mlPageStrNum
        If lsChkPage = msPageString(liLoopCnt) Then
'            mlPageAccess(liLoopCnt) = mlPageAccess(liLoopCnt) + 1
            mlPageTemp = liLoopCnt
            Exit For
        End If
    Next liLoopCnt

    If (liLoopCnt - 1) = mlPageStrNum Then
        mlPageStrNum = mlPageStrNum + 1
        ReDim Preserve msPageString(mlPageStrNum)
        ReDim Preserve mlPageAccess(mlPageStrNum)
        msPageString(mlPageStrNum) = lsChkPage
'        mlPageAccess(mlPageStrNum) = 1
        mlPageTemp = mlPageStrNum
    End If

    lsChkPage = "(" & basParam.aaParamValue(csPage, 1) & ")"
    If (basParam.aaParamValue(csSpecifyPage) = False) Or (InStr(psChkLine, "1#" & lsChkPage) > 0) Then
        aaCheckDate = aaCheckDate Or 2
    End If
'        If basParam.aaParamValue(csShareWare) = False Then
'            liSpacePos = InStr(psChkLine, ")") + 1
'            ldAccessDate = Mid(psChkLine, liSpacePos, InStr(psChkLine, " ") - liSpacePos)
'            ldStartDate = basParam.aaParamValue(csStartDate)
'            ldEndDate = basParam.aaParamValue(csEndDate)
'            If (basParam.aaParamValue(csSpecifyDate) = False) Or ((ldStartDate <= ldAccessDate) And (ldAccessDate <= ldEndDate)) Then
'                mlMonthTemp = Format(ldAccessDate, "m")
'                mlWWeekTemp = Format(ldAccessDate, "ww")
'                mlDWeekTemp = Format(ldAccessDate, "w")
'                mlDaysTemp = Format(ldAccessDate, "d")
'                mlHourTemp = Format(Mid$(psChkLine, InStr(psChkLine, " ")), "h")
'                aaCheckDate = 1
'            End If
'        Else
            lsStartDate = Format(basParam.aaParamValue(csStartDate), "yyyy/m/d")
            lsEndDate = Format(basParam.aaParamValue(csEndDate), "yyyy/m/d")
            lsWorkLine = psChkLine & Chr(0)
            llRet = aa_check_date(mlMonthTemp, mlWWeekTemp, mlDWeekTemp, mlDaysTemp, mlHourTemp, lsWorkLine, lsStartDate, lsEndDate, basParam.aaParamValue(csSpecifyDate))
            If llRet = 1 Then
                aaCheckDate = aaCheckDate Or 1
            End If
'        End If
'    End If
End Function

Private Sub aaCheckOsBrws(ByVal psChkLine As String)
'---------------------------------------------------------------------------
'    : aaCheckOsBrws()
' @@@\ : nr̃`FbN
' @@ : (I) psChkLine      `FbNs
'   l : Ȃ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim lsChkLine       As String       ' p

    If psChkLine <> "2#" Then
        If basParam.aaParamValue(csSearchLike) <> False Then
            ' nr
            For liLoopCnt = 1 To mlOsStrNum
                If psChkLine Like msOsFindStr(liLoopCnt) Then
'                    mlOsAccess(liLoopCnt) = mlOsAccess(liLoopCnt) + 1
                    mlOsTemp = liLoopCnt
                    Exit For
                End If
            Next liLoopCnt

            ' uEU
            For liLoopCnt = 1 To mlBrwsStrNum
                If psChkLine Like msBrwsFindStr(liLoopCnt) Then
'                    mlBrwsAccess(liLoopCnt) = mlBrwsAccess(liLoopCnt) + 1
                    mlBrwsTemp = liLoopCnt
                    Exit For
                End If
            Next liLoopCnt
        Else
            ' nr
            For liLoopCnt = 1 To mlOsStrNum
                If InStr(psChkLine, msOsFindStr(liLoopCnt)) Then
'                    mlOsAccess(liLoopCnt) = mlOsAccess(liLoopCnt) + 1
                    mlOsTemp = liLoopCnt
                    Exit For
                End If
            Next liLoopCnt

            ' uEU
            For liLoopCnt = 1 To mlBrwsStrNum
                If InStr(psChkLine, msBrwsFindStr(liLoopCnt)) Then
'                    mlBrwsAccess(liLoopCnt) = mlBrwsAccess(liLoopCnt) + 1
                    mlBrwsTemp = liLoopCnt
                    Exit For
                End If
            Next liLoopCnt
        End If

        ' G[WFgf[^
        If Len(psChkLine) > 2 Then
            lsChkLine = Mid$(psChkLine, 3)
            For liLoopCnt = 1 To mlAgentStrNum
                If lsChkLine = msAgentString(liLoopCnt) Then
                    mlAgentTemp = liLoopCnt
                    Exit For
                End If
            Next liLoopCnt

            If (liLoopCnt - 1) = mlAgentStrNum Then
                mlAgentStrNum = mlAgentStrNum + 1
                ReDim Preserve msAgentString(mlAgentStrNum)
                ReDim Preserve mlAgentAccess(mlAgentStrNum)
                msAgentString(mlAgentStrNum) = lsChkLine
                mlAgentTemp = mlAgentStrNum
            End If
        End If
    End If
End Sub

Private Sub aaCheckRef(ByVal psChkLine As String)
'---------------------------------------------------------------------------
'    : aaCheckRef()
' @@@\ : Oʂ̃`FbN
' @@ : (I) psChkLine      `FbNs
'   l : Ȃ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim lsChkLine       As String       ' p
    Dim liPos           As Integer      ' ʒu
    Dim liNumPos        As Integer      ' ^̈ʒu
    Dim liPortNoLen     As Integer      ' |[gԍ̒
    Dim lsPortNo        As String       ' |[gԍ
    Dim lsTempStr       As String       ' Ɨp

    On Error Resume Next

    If Len(psChkLine) > 2 Then
        lsChkLine = Mid$(psChkLine, 3)
        If basParam.aaParamValue(csCodeChange) <> False Then
            lsChkLine = aaModifyChrCode(lsChkLine)
        End If
        If basParam.aaParamValue(csIgnoreIndex) <> False Then
            lsChkLine = aaDeleteIndex(lsChkLine)
        End If
        If basParam.aaParamValue(csIgnoreQuestion) <> False Then
            lsChkLine = aaIgnoreString(lsChkLine, "?")
        End If
        If basParam.aaParamValue(csIgnoreSharp) <> False Then
            lsChkLine = aaIgnoreString(lsChkLine, "#")
        End If
        If basParam.aaParamValue(csIgnorePortNo) <> False Then
            liPos = InStr(lsChkLine, ":")
            Do While liPos > 0
                liNumPos = InStr(liPos, lsChkLine, "/")
                If liNumPos = 0 Then
                    liNumPos = Len(lsChkLine) + 1
                End If
                lsPortNo = Mid(lsChkLine, liPos + 1, liNumPos - liPos - 1)
                liPortNoLen = Len(lsPortNo)
                lsPortNo = Val(lsPortNo)
                If (lsPortNo <> "0") And (liPortNoLen = Len(lsPortNo)) Then
                    lsTempStr = Left(lsChkLine, liPos - 1) & Right(lsChkLine, Len(lsChkLine) - liNumPos + 1)
                End If
                liPos = InStr(liNumPos, lsChkLine, ":")
            Loop
            If lsTempStr <> "" Then
                lsChkLine = lsTempStr
            End If
        End If

        If basParam.aaParamValue(csSmallize) <> False Then
            lsChkLine = LCase(lsChkLine)
        End If

        If lsChkLine <> "" Then
            For liLoopCnt = 1 To mlRefStrNum
                If lsChkLine = msRefString(liLoopCnt) Then
'                    mlRefAccess(liLoopCnt) = mlRefAccess(liLoopCnt) + 1
                    mlRegTemp = liLoopCnt
                    Exit For
                End If
            Next liLoopCnt

            If (liLoopCnt - 1) = mlRefStrNum Then
                mlRefStrNum = mlRefStrNum + 1
                ReDim Preserve msRefString(mlRefStrNum)
                ReDim Preserve mlRefAccess(mlRefStrNum)
                msRefString(mlRefStrNum) = lsChkLine
'                mlRefAccess(mlRefStrNum) = 1
                mlRegTemp = mlRefStrNum
            End If
        End If

        lsChkLine = Mid$(psChkLine, 3)
        For liLoopCnt = 1 To mlRefTrueStrNum
            If lsChkLine = msRefTrueString(liLoopCnt) Then
'                mlRefTrueAccess(liLoopCnt) = mlRefTrueAccess(liLoopCnt) + 1
                mlRefTrueTemp = liLoopCnt
                Exit For
            End If
        Next liLoopCnt

        If (liLoopCnt - 1) = mlRefTrueStrNum Then
            mlRefTrueStrNum = mlRefTrueStrNum + 1
            ReDim Preserve msRefTrueString(mlRefTrueStrNum)
            ReDim Preserve mlRefTrueAccess(mlRefTrueStrNum)
            msRefTrueString(mlRefTrueStrNum) = lsChkLine
'            mlRefTrueAccess(mlRefTrueStrNum) = 1
            mlRefTrueTemp = mlRefTrueStrNum
        End If
    End If
End Sub

Private Function aaModifyChrCode(ByVal psCheckString As String) As String
'---------------------------------------------------------------------------
'    : aaModifyChrCode()
' @@@\ : R[hϊ
' @@ : (I) psCheckString  `FbN镶
'   l : R[hϊ
' @@ : 2000/01/15
'---------------------------------------------------------------------------
    Dim liBeforePos     As Integer      ' PÕ`FbNʒu
    Dim liCurPos        As Integer      ' `FbNʒu
    Dim lsChrCode       As String       ' R[h
    Dim lsModifyString  As String       ' ύX̕

    On Error Resume Next

    liCurPos = InStr(psCheckString, "%")
    liBeforePos = 1
    If liCurPos > 0 Then
        Do While liCurPos > 0
            lsModifyString = lsModifyString & Mid$(psCheckString, liBeforePos, (liCurPos) - liBeforePos)
            lsChrCode = Mid$(psCheckString, liCurPos + 1, 2)
            lsModifyString = lsModifyString & Chr("&H" & lsChrCode)
            liBeforePos = liCurPos + 3
            liCurPos = InStr(liBeforePos, psCheckString, "%")
            If liCurPos = 0 Then
                lsModifyString = lsModifyString & Right$(psCheckString, Len(psCheckString) - liBeforePos + 1)
            End If
        Loop
    Else
        lsModifyString = psCheckString
    End If

    aaModifyChrCode = lsModifyString
End Function

Private Function aaDeleteIndex(ByVal psCheckString As String) As String
'---------------------------------------------------------------------------
'    : aaDeleteIndex()
' @@@\ : index.html ̍폜
' @@ : (I) psCheckString  `FbN镶
'   l : ϊ̕
' @@ : 2000/01/15
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim liCurPos        As Integer      ' index.html ̈ʒu
    Dim lsCheckString   As String       ' `FbN镶
    Dim lsModifyString  As String       ' ύX̕

    On Error Resume Next

    lsModifyString = psCheckString
    If mlIgnoreIndexNum > 0 Then
        lsCheckString = LCase(psCheckString)
        For liLoopCnt = 1 To mlIgnoreIndexNum
            liCurPos = InStr(lsCheckString, msIgnoreIndex(liLoopCnt))
            If liCurPos > 0 Then
                lsModifyString = Left$(psCheckString, liCurPos - 1)
                lsCheckString = LCase(lsModifyString)
            End If
        Next liLoopCnt
    End If

    aaDeleteIndex = lsModifyString
End Function

Private Function aaIgnoreString(ByVal psCheckString As String, ByVal psIgnoreString) As String
'---------------------------------------------------------------------------
'    : aaIgnoreString()
' @@@\ : w蕶ȍ~̍폜
' @@ : (I) psCheckString  `FbN镶
'          : (I) psIgnoreString 镶
'   l : ϊ̕
' @@ : 2000/01/20
'---------------------------------------------------------------------------
    Dim liCurPos        As Integer      ' w蕶̈ʒu
    Dim lsModifyString  As String       ' ύX̕

    On Error Resume Next

    liCurPos = InStr(psCheckString, psIgnoreString)
    If liCurPos > 0 Then
        lsModifyString = Left$(psCheckString, liCurPos - 1)
    Else
        lsModifyString = psCheckString
    End If

    aaIgnoreString = lsModifyString
End Function

Private Function aaCheckHostIp(ByVal psChkLine As String) As Integer
'---------------------------------------------------------------------------
'    : aaCheckHostIp()
' @@@\ : zXg̃`FbN
' @@ : (I) psChkLine      `FbNs
'   l : Ȃ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim liPeriodNum     As Integer      ' sIh
    Dim liCurPos        As Integer      ' ݂̈ʒui|C^j
    Dim lsChkLine       As String       ' p
    Dim liClassA        As Integer      ' 擪Wrbgl
    Dim liClassB        As Integer      ' ̂Wrbgl
    Dim liClassC        As Integer      ' ̎̂Wrbgl

    aaCheckHostIp = 0
    On Error Resume Next

    If basParam.aaParamValue(csSpecifyHost) <> False Then
        psChkLine = aaDeleteHost(psChkLine)
    End If

    If psChkLine <> "" Then
        If Mid$(psChkLine, 3, 1) <> "(" Then
            lsChkLine = Mid$(psChkLine, 3, InStr(psChkLine, "(") - 3)
            liCurPos = InStr(lsChkLine, ".")
            Do While liCurPos <> 0
                liCurPos = InStr(lsChkLine, ".")
                If liCurPos <> 0 Then
                    liPeriodNum = liPeriodNum + 1
                    lsChkLine = Mid$(lsChkLine, liCurPos + 1)
                End If
            Loop

            lsChkLine = Val(lsChkLine)
        End If

        If lsChkLine = "0" Then
            lsChkLine = Mid$(psChkLine, 3, InStr(psChkLine, "(") - 3)
            If basParam.aaParamValue(csSmallize) <> False Then
                lsChkLine = LCase(lsChkLine)
            End If
            If liPeriodNum <> 0 Then
                If liPeriodNum >= 4 Then
                    liPeriodNum = liPeriodNum - 2
                Else
                    liPeriodNum = 1
                End If
                For liLoopCnt = 1 To liPeriodNum
                    liCurPos = InStr(lsChkLine, ".")
                    lsChkLine = Mid$(lsChkLine, liCurPos + 1)
                Next liLoopCnt
                lsChkLine = "*." & lsChkLine
            End If
        Else
            If basParam.aaParamValue(csIgnoreIp) = False Then
                liCurPos = InStr(psChkLine, "(") + 1
                lsChkLine = Mid$(psChkLine, liCurPos)
                If basParam.aaParamValue(csSpecifyClass) = False Then
                    lsChkLine = Left$(lsChkLine, Len(lsChkLine) - 1)
                Else
                    liCurPos = InStr(lsChkLine, ".")
                    liClassA = Left$(lsChkLine, liCurPos - 1)
                    lsChkLine = Mid$(lsChkLine, liCurPos + 1)

                    liCurPos = InStr(lsChkLine, ".")
                    liClassB = Left$(lsChkLine, liCurPos - 1)
                    lsChkLine = Mid$(lsChkLine, liCurPos + 1)

                    liCurPos = InStr(lsChkLine, ".")
                    liClassC = Left$(lsChkLine, liCurPos - 1)
                    lsChkLine = Mid$(lsChkLine, liCurPos + 1)

                    If liClassA < 127 Then
                        lsChkLine = liClassA & ".*.*.*"
                    ElseIf liClassA < 192 Then
                        lsChkLine = liClassA & "." & liClassB & ".*.*"
                    ElseIf liClassA < 224 Then
                        lsChkLine = liClassA & "." & liClassB & "." & liClassC & ".*"
                    Else
                        lsChkLine = liClassA & "." & liClassB & "." & liClassC & "." & Left(lsChkLine, Len(lsChkLine) - 1)
                    End If
                End If

'            lsChkLine = Left$(lsChkLine, Len(lsChkLine) - 1)
'            Do While Len(lsChkLine) > 0
'                If Right$(lsChkLine, 1) = "." Then
'                    lsChkLine = Left$(lsChkLine, Len(lsChkLine) - 1) & ".*"
'                    Exit Do
'                End If
'                lsChkLine = Left$(lsChkLine, Len(lsChkLine) - 1)
'            Loop
            Else
                Exit Function
            End If
        End If

        For liLoopCnt = 1 To mlHostStrNum
            If lsChkLine = msHostString(liLoopCnt) Then
                mlHostAccess(liLoopCnt) = mlHostAccess(liLoopCnt) + 1
                aaCheckHostIp = 1
                Exit For
            End If
        Next liLoopCnt

        If (liLoopCnt - 1) = mlHostStrNum Then
            mlHostStrNum = mlHostStrNum + 1
            ReDim Preserve msHostString(mlHostStrNum)
            ReDim Preserve mlHostAccess(mlHostStrNum)
            msHostString(mlHostStrNum) = lsChkLine
            mlHostAccess(mlHostStrNum) = 1
            aaCheckHostIp = 1
        End If
    End If
End Function

Private Function aaDeleteHost(ByVal psCheckString As String) As String
'---------------------------------------------------------------------------
'    : aaDeleteHost()
' @@@\ : ͑ΏۊÕzXg̍폜
' @@ : (I) psCheckString  `FbN镶
'   l : ϊ̕
' @@ : 2000/09/15
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim liCurPos        As Integer      ' zXg̈ʒu
    Dim lsModifyString  As String       ' ύX̕

    On Error Resume Next

    lsModifyString = psCheckString
    If mlIgnoreHostNum > 0 Then
        psCheckString = LCase(psCheckString)
        If basParam.aaParamValue(csIgnoreHost) <> False Then
            For liLoopCnt = 1 To mlIgnoreHostNum
                liCurPos = InStr(psCheckString, msIgnoreHost(liLoopCnt))
                If liCurPos > 0 Then
                    lsModifyString = ""
                    Exit For
                End If
            Next liLoopCnt
        Else
            For liLoopCnt = 1 To mlIgnoreHostNum
                liCurPos = InStr(psCheckString, msIgnoreHost(liLoopCnt))
                If liCurPos = 0 Then
                    lsModifyString = ""
                    Exit For
                End If
            Next liLoopCnt
        End If
    End If

    aaDeleteHost = lsModifyString
End Function

Private Sub aaSortAccess(ByRef plAccess() As Long, ByRef psAcStr() As String, ByVal plStratIndex As Long, ByVal plEndIndex As Long)
'---------------------------------------------------------------------------
'    : aaSortAccess()
' @@@\ : f[^̕בւ
' @@ : (I/O) plAccess     בւ鐔l
'          : (I/O) psAcStr      t
'          : (I) plStratIndex   Jnԍ
'          : (I) plEndIndex     Iԍ
'   l : Ȃ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim llForward       As Long         ' }ʒu
    Dim llBackward      As Long         ' }ʒu
    Dim llRef           As Long         ' Jnl
    Dim lsRef           As String       '
    Dim llTempValue     As Long         ' ւƗp
    Dim lsTempValue     As String       '

    On Error Resume Next

    If plStratIndex < plEndIndex Then
        llRef = plAccess(plStratIndex)
        lsRef = psAcStr(plStratIndex)
        llForward = plStratIndex
        llBackward = plEndIndex + 1

        Do While 1
            Do While llForward <= plEndIndex
                llForward = llForward + 1
                If plAccess(llForward) > llRef Then
                    Exit Do
                ElseIf plAccess(llForward) = llRef Then
                    If psAcStr(llForward) <= lsRef Then
                        Exit Do
                    End If
                End If
            Loop
            Do While llBackward >= plStratIndex
                llBackward = llBackward - 1
                If plAccess(llBackward) < llRef Then
                    Exit Do
                ElseIf plAccess(llBackward) = llRef Then
                    If psAcStr(llBackward) >= lsRef Then
                        Exit Do
                    End If
                End If
            Loop
            If llForward >= llBackward Then
                Exit Do
            End If

            llTempValue = plAccess(llForward)
            plAccess(llForward) = plAccess(llBackward)
            plAccess(llBackward) = llTempValue
            lsTempValue = psAcStr(llForward)
            psAcStr(llForward) = psAcStr(llBackward)
            psAcStr(llBackward) = lsTempValue
        Loop
        plAccess(plStratIndex) = plAccess(llBackward)
        psAcStr(plStratIndex) = psAcStr(llBackward)
        plAccess(llBackward) = llRef
        psAcStr(llBackward) = lsRef

        aaSortAccess plAccess, psAcStr, plStratIndex, llBackward - 1
        aaSortAccess plAccess, psAcStr, llBackward + 1, plEndIndex
    End If
End Sub

Private Sub aaJointAccess(ByRef plAccess() As Long, ByRef psAcStr() As String, ByVal plStratIndex As Long, ByVal plEndIndex As Long)
'---------------------------------------------------------------------------
'    : aaJointAccess()
' @@@\ : f[^̌
' @@ : (I/O) plAccess     l
'          : (I/O) psAcStr      
'          : (I) plStratIndex   Jnԍ
'          : (I) plEndIndex     Iԍ
'   l : Ȃ
' @@ : 2000/01/30
'---------------------------------------------------------------------------
    Dim llMainLoop      As Long         ' [vJE^
    Dim llSubLoop       As Long         ' [vJE^

    On Error Resume Next

    For llMainLoop = plStratIndex To (plEndIndex - 1)
        If plAccess(llMainLoop) > 0 Then
            For llSubLoop = (llMainLoop + 1) To plEndIndex
                If psAcStr(llMainLoop) = psAcStr(llSubLoop) Then
                    plAccess(llMainLoop) = plAccess(llMainLoop) + plAccess(llSubLoop)
                    plAccess(llSubLoop) = 0
                End If
            Next llSubLoop
        End If
    Next llMainLoop
End Sub

Public Function aaWriteAccessFile(ByVal psFileName As String, ByVal psFileExt As Integer) As Boolean
'---------------------------------------------------------------------------
'    : aaWriteAccessFile()
' @@@\ : ʂt@Cɏo͂
' @@ : (I) psFileName     o̓t@C
'          : (I) psFileExt      o͌`
'          :                      eiFileExtTxt= eLXg,
'          :                      eiFileExtCsv= bru`
'          :                      eiFileExtHtml= gslk`
'   l : True= , False= s
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    If psFileExt = eiFileExtTxt Then
        aaWriteAccessTxtFile psFileName
    ElseIf psFileExt = eiFileExtCsv Then
        aaWriteAccessCsvFile psFileName
    Else
        aaWriteAccessHtmlFile psFileName
    End If
End Function

Private Function aaWriteAccessTxtFile(ByVal psFileName As String) As Boolean
'---------------------------------------------------------------------------
'    : aaWriteAccessTxtFile()
' @@@\ : ʂt@Cɏo͂ieLXg`j
' @@ : (I) psFileName     o̓t@C
'   l : True= , False= s
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim liRetCode       As Integer      ' ߂l
    Dim llLoopCnt       As Long         ' [vJE^
    Dim lsOutputStr     As String       ' o͕
    Dim lsFormatStr     As String       ' o̓tH[}bg

    On Error GoTo aaWriteAccessTxtFile_Error

    liFileNo = FreeFile
    lsFormatStr = Left$("@@@@@@@@@@@@@@@", Len(mlAccessNum))
    Open psFileName For Output As liFileNo

    If basParam.aaParamValue(csSpecifyDate) = False Then
        Print #liFileNo, "͓t: wȂ"
    Else
        Print #liFileNo, "͓t: " & _
            Format(basParam.aaParamValue(csStartDate), "yyyy/m/d") & " ` " & Format(basParam.aaParamValue(csEndDate), "yyyy/m/d")
    End If
    If basParam.aaParamValue(csSpecifyPage) = False Then
        Print #liFileNo, "͏: wȂ"
    Else
        Print #liFileNo, "͏: " & "(" & basParam.aaParamValue(csPage, 1) & ")"
    End If

    ' ANZXv
    Print #liFileNo, vbCrLf & "ANZXv: " & mlAccessNum

    ' 
    Print #liFileNo, vbCrLf & ""
    For llLoopCnt = 1 To 12
        If mlMonthAccess(llLoopCnt) > 0 Then
            Print #liFileNo, Format(llLoopCnt, "@@") & ":" & Format(mlMonthAccess(llLoopCnt), lsFormatStr)
        End If
    Next llLoopCnt

    ' T
    Print #liFileNo, vbCrLf & "T"
    For llLoopCnt = 1 To 54
        If mlWWeekAccess(llLoopCnt) > 0 Then
            Print #liFileNo, " " & Format(llLoopCnt, "@@") & "T:" & Format(mlWWeekAccess(llLoopCnt), lsFormatStr)
        End If
    Next llLoopCnt

    ' j
    Print #liFileNo, vbCrLf & "j"
    For llLoopCnt = 1 To 7
        If mlDWeekAccess(llLoopCnt) > 0 Then
            Print #liFileNo, Format(llLoopCnt, "aaa") & ":" & Format(mlDWeekAccess(llLoopCnt), lsFormatStr)
        End If
    Next llLoopCnt

    ' t
    Print #liFileNo, vbCrLf & "t"
    For llLoopCnt = 1 To 31
        If mlDateAccess(llLoopCnt) > 0 Then
            Print #liFileNo, Format(llLoopCnt, "@@") & ":" & Format(mlDateAccess(llLoopCnt), lsFormatStr)
        End If
    Next llLoopCnt

    ' ԕ
    Print #liFileNo, vbCrLf & "ԕ"
    For llLoopCnt = 0 To 24
        If mlTimeAccess(llLoopCnt) > 0 Then
            Print #liFileNo, Format(llLoopCnt, "@@") & ":" & Format(mlTimeAccess(llLoopCnt), lsFormatStr)
        End If
    Next llLoopCnt

    ' nr
    Print #liFileNo, vbCrLf & "nr"
    For llLoopCnt = mlOsStrNum To 1 Step -1
        If mlOsAccess(llLoopCnt) > 0 Then
            Print #liFileNo, Format(mlOsAccess(llLoopCnt), lsFormatStr) & ": " & msOsString(llLoopCnt)
        End If
    Next llLoopCnt

    ' uEU
    Print #liFileNo, vbCrLf & "uEU"
    For llLoopCnt = mlBrwsStrNum To 1 Step -1
        If mlBrwsAccess(llLoopCnt) > 0 Then
            Print #liFileNo, Format(mlBrwsAccess(llLoopCnt), lsFormatStr) & ": " & msBrwsString(llLoopCnt)
        End If
    Next llLoopCnt

    ' G[WFg
    Print #liFileNo, vbCrLf & "G[WFg (" & mlAgentStrNum & ")"
    For llLoopCnt = mlAgentStrNum To 1 Step -1
        Print #liFileNo, Format(mlAgentAccess(llLoopCnt), lsFormatStr) & ": " & msAgentString(llLoopCnt)
    Next llLoopCnt

    ' zXg
    Print #liFileNo, vbCrLf & "zXg (" & mlHostStrNum & ")"
    For llLoopCnt = mlHostStrNum To 1 Step -1
        Print #liFileNo, Format(mlHostAccess(llLoopCnt), lsFormatStr) & ": " & msHostString(llLoopCnt)
    Next llLoopCnt

    ' Oʕ
    Print #liFileNo, vbCrLf & "Oʕ (" & mlRefStrNum & ")"
    For llLoopCnt = mlRefStrNum To 1 Step -1
        Print #liFileNo, Format(mlRefAccess(llLoopCnt), lsFormatStr) & ": " & msRefString(llLoopCnt)
    Next llLoopCnt

    ' y[W
    Print #liFileNo, vbCrLf & "y[W (" & mlPageStrNum & ")"
    For llLoopCnt = mlPageStrNum To 1 Step -1
        Print #liFileNo, Format(mlPageAccess(llLoopCnt), lsFormatStr) & ": " & msPageString(llLoopCnt)
    Next llLoopCnt

    Close liFileNo
    aaWriteAccessTxtFile = True
    Exit Function

aaWriteAccessTxtFile_Error:
    liRetCode = MsgBox("t@C݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    aaWriteAccessTxtFile = False
End Function

Private Function aaWriteAccessCsvFile(ByVal psFileName As String) As Boolean
'---------------------------------------------------------------------------
'    : aaWriteAccessCsvFile()
' @@@\ : ʂt@Cɏo͂ibru`j
' @@ : (I) psFileName     o̓t@C
'   l : True= , False= s
' @@ : 2000/02/10
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim liRetCode       As Integer      ' ߂l
    Dim llLoopCnt       As Long         ' [vJE^
    Dim lsOutputStr     As String       ' o͕

    On Error GoTo aaWriteAccessCsvFile_Error

    liFileNo = FreeFile
    Open psFileName For Output As liFileNo

    If basParam.aaParamValue(csSpecifyDate) = False Then
        Print #liFileNo, """͓t"",""wȂ"""
    Else
        Print #liFileNo, """͓t"",""" & _
            Format(basParam.aaParamValue(csStartDate), "yyyy/m/d") & " ` " & Format(basParam.aaParamValue(csEndDate), "yyyy/m/d") & _
            """"
    End If
    If basParam.aaParamValue(csSpecifyPage) = False Then
        Print #liFileNo, """͏"",""wȂ"""
    Else
        Print #liFileNo, """͏""," & """(" & basParam.aaParamValue(csPage, 1) & ")"""
    End If

    ' ANZXv
    Print #liFileNo, vbCrLf & """ANZXv""," & mlAccessNum

    ' 
    Print #liFileNo, vbCrLf & """"""
    For llLoopCnt = 1 To 12
        If mlMonthAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & llLoopCnt & """," & mlMonthAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' T
    Print #liFileNo, vbCrLf & """T"""
    For llLoopCnt = 1 To 54
        If mlWWeekAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & llLoopCnt & "T""," & mlWWeekAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' j
    Print #liFileNo, vbCrLf & """j"""
    For llLoopCnt = 1 To 7
        If mlDWeekAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & Format(llLoopCnt, "aaa") & """," & mlDWeekAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' t
    Print #liFileNo, vbCrLf & """t"""
    For llLoopCnt = 1 To 31
        If mlDateAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & llLoopCnt & """," & mlDateAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' ԕ
    Print #liFileNo, vbCrLf & """ԕ"""
    For llLoopCnt = 0 To 24
        If mlTimeAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & llLoopCnt & """," & mlTimeAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' nr
    Print #liFileNo, vbCrLf & """nr"""
    For llLoopCnt = mlOsStrNum To 1 Step -1
        If mlOsAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & msOsString(llLoopCnt) & """" & "," & mlOsAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' uEU
    Print #liFileNo, vbCrLf & """uEU"""
    For llLoopCnt = mlBrwsStrNum To 1 Step -1
        If mlBrwsAccess(llLoopCnt) > 0 Then
            Print #liFileNo, """" & msBrwsString(llLoopCnt) & """" & "," & mlBrwsAccess(llLoopCnt)
        End If
    Next llLoopCnt

    ' G[WFg
    Print #liFileNo, vbCrLf & """G[WFg""," & mlAgentStrNum
    For llLoopCnt = mlAgentStrNum To 1 Step -1
        Print #liFileNo, """" & msAgentString(llLoopCnt) & """" & "," & mlAgentAccess(llLoopCnt)
    Next llLoopCnt

    ' zXg
    Print #liFileNo, vbCrLf & """zXg""," & mlHostStrNum
    For llLoopCnt = mlHostStrNum To 1 Step -1
        Print #liFileNo, """" & msHostString(llLoopCnt) & """" & "," & mlHostAccess(llLoopCnt)
    Next llLoopCnt

    ' Oʕ
    Print #liFileNo, vbCrLf & """Oʕ""," & mlRefStrNum
    For llLoopCnt = mlRefStrNum To 1 Step -1
        Print #liFileNo, """" & msRefString(llLoopCnt) & """" & "," & mlRefAccess(llLoopCnt)
    Next llLoopCnt

    ' y[W
    Print #liFileNo, vbCrLf & """y[W""," & mlPageStrNum
    For llLoopCnt = mlPageStrNum To 1 Step -1
        Print #liFileNo, """" & msPageString(llLoopCnt) & """" & "," & mlPageAccess(llLoopCnt)
    Next llLoopCnt

    Close liFileNo
    aaWriteAccessCsvFile = True
    Exit Function

aaWriteAccessCsvFile_Error:
    liRetCode = MsgBox("t@C݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    aaWriteAccessCsvFile = False
End Function

Private Function aaWriteAccessHtmlFile(ByVal psFileName As String) As Boolean
'---------------------------------------------------------------------------
'    : aaWriteAccessHtmlFile()
' @@@\ : ʂt@Cɏo͂igslk`j
' @@ : (I) psFileName     o̓t@C
'   l : True= , False= s
' @@ : 2000/03/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim liRetCode       As Integer      ' ߂l
    Dim llLoopCnt       As Long         ' [vJE^
    Dim lsOutputStr     As String       ' o͕
    Dim lsNowDate       As String       ' ݂̓t
    Dim ldMaxValue      As Double       ' eڂ̍ől
    Dim lsEndDiv        As String       ' <div> ̏I
    Dim lsFolderName    As String       ' tH_[

    lsFolderName = psFileName
    Do While Len(lsFolderName) > 0
        If Right$(lsFolderName, 1) = "\" Then
            Exit Do
        End If
        lsFolderName = Left$(lsFolderName, Len(lsFolderName) - 1)
    Loop
    aacWriteGifFile lsFolderName

    On Error GoTo aaWriteAccessHtmlFile_Error
    lsNowDate = Format(Now, "yyyy-m-d h:n:s")
'    lsEndDiv = aacAddEndDiv
    lsEndDiv = "</div>"

    liFileNo = FreeFile
    Open psFileName For Output As liFileNo
    Print #liFileNo, "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.0//EN"">"
    Print #liFileNo, "<html lang=""ja"">"
    Print #liFileNo, "<head>"
    Print #liFileNo, vbTab & "<meta http-equiv=""Content-Type"" content=""text/html; charset=Shift_JIS"">"
    Print #liFileNo, vbTab & "<meta http-equiv=""Expires"" content=""" & lsNowDate & """>"
    Print #liFileNo, vbTab & "<meta name=""author"" content=""acalz"">"
    Print #liFileNo, vbTab & "<meta name=""copyright"" content=""&copy; 1999,2000 Whitire Company"">"
    Print #liFileNo, vbTab & "<meta name=""date"" content=""" & lsNowDate & """>"
    Print #liFileNo, vbTab & "<title>goANZX</title>"
    Print #liFileNo, "</head>"
    Print #liFileNo, "<body>"

    Print #liFileNo, "<div>"
    Print #liFileNo, vbTab & "<strong>z[y[WANZX</strong>"
    Print #liFileNo, vbTab & "<br><br>"
    If basParam.aaParamValue(csSpecifyDate) = False Then
        Print #liFileNo, vbTab & "͓tF wȂ<br>"
    Else
        Print #liFileNo, vbTab & "͓tF " & _
            Format(basParam.aaParamValue(csStartDate), "yyyy/m/d") & " ` " & Format(basParam.aaParamValue(csEndDate), "yyyy/m/d") & "<br>"
    End If
    If basParam.aaParamValue(csSpecifyPage) = False Then
        Print #liFileNo, vbTab & "͏F wȂ<br>"
    Else
        Print #liFileNo, vbTab & "͏F (" & basParam.aaParamValue(csPage, 1) & ")<br>"
    End If
    Print #liFileNo, vbTab & "ANZXvF " & mlAccessNum & "<br>"
    Print #liFileNo, "</div>"

    ' j[
    Print #liFileNo, "<div>"
    Print #liFileNo, vbTab & "<br>"
    Print #liFileNo, vbTab & "<table summary=""Menu"">"
    Print #liFileNo, vbTab & "<tr>"
    Print #liFileNo, aacPutMenuString("month", "")
    Print #liFileNo, aacPutMenuString("week", "T")
    Print #liFileNo, aacPutMenuString("dweek", "j")
    Print #liFileNo, aacPutMenuString("date", "t")
    Print #liFileNo, aacPutMenuString("time", "")
    Print #liFileNo, vbTab & "</tr>"
    Print #liFileNo, vbTab & "<tr>"
    Print #liFileNo, aacPutMenuString("os", "nr")
    Print #liFileNo, aacPutMenuString("brws", "uEU")
    Print #liFileNo, aacPutMenuString("ob", "G[WFg")
    Print #liFileNo, aacPutMenuString("host", "zXg")
    Print #liFileNo, aacPutMenuString("ref", "O")
    Print #liFileNo, aacPutMenuString("page", "y[W")
    Print #liFileNo, vbTab & "</tr>"
    Print #liFileNo, vbTab & "</table>"
    Print #liFileNo, "</div>"

    ' 
    Print #liFileNo, aacAddStartDiv("month", "")
    For llLoopCnt = 1 To 12
        If ldMaxValue < mlMonthAccess(llLoopCnt) Then
            ldMaxValue = mlMonthAccess(llLoopCnt)
        End If
    Next llLoopCnt
    If ldMaxValue > 0 Then
        ldMaxValue = ciMaxHtmlValue / ldMaxValue
        For llLoopCnt = 1 To 12
            If mlMonthAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar(llLoopCnt & "(" & mlMonthAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlMonthAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' T
    Print #liFileNo, aacAddStartDiv("week", "T")
    ldMaxValue = 0
    For llLoopCnt = 1 To 54
        If ldMaxValue < mlWWeekAccess(llLoopCnt) Then
            ldMaxValue = mlWWeekAccess(llLoopCnt)
        End If
    Next llLoopCnt
    If ldMaxValue > 0 Then
        ldMaxValue = ciMaxHtmlValue / ldMaxValue

        For llLoopCnt = 1 To 54
            If mlWWeekAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar("" & llLoopCnt & "T(" & mlWWeekAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlWWeekAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' j
    Print #liFileNo, aacAddStartDiv("dweek", "j")
    ldMaxValue = 0
    For llLoopCnt = 1 To 7
        If ldMaxValue < mlDWeekAccess(llLoopCnt) Then
            ldMaxValue = mlDWeekAccess(llLoopCnt)
        End If
    Next llLoopCnt
    If ldMaxValue > 0 Then
        ldMaxValue = ciMaxHtmlValue / ldMaxValue

        For llLoopCnt = 1 To 7
            If mlDWeekAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar(Format(llLoopCnt, "aaa") & "j(" & mlDWeekAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlDWeekAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' t
    Print #liFileNo, aacAddStartDiv("date", "t")
    ldMaxValue = 0
    For llLoopCnt = 1 To 31
        If ldMaxValue < mlDateAccess(llLoopCnt) Then
            ldMaxValue = mlDateAccess(llLoopCnt)
        End If
    Next llLoopCnt
    If ldMaxValue > 0 Then
        ldMaxValue = ciMaxHtmlValue / ldMaxValue

        For llLoopCnt = 1 To 31
            If mlDateAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar(llLoopCnt & "(" & mlDateAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlDateAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' ԕ
    Print #liFileNo, aacAddStartDiv("time", "")
    ldMaxValue = 0
    For llLoopCnt = 0 To 24
        If ldMaxValue < mlTimeAccess(llLoopCnt) Then
            ldMaxValue = mlTimeAccess(llLoopCnt)
        End If
    Next llLoopCnt
    If ldMaxValue > 0 Then
        ldMaxValue = ciMaxHtmlValue / ldMaxValue

        For llLoopCnt = 0 To 24
            If mlTimeAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar(llLoopCnt & "(" & mlTimeAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlTimeAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' nr
    Print #liFileNo, aacAddStartDiv("os", "nr")
    If mlOsAccess(mlOsStrNum) > 0 Then
        ldMaxValue = ciMaxHtmlValue / mlOsAccess(mlOsStrNum)
        For llLoopCnt = mlOsStrNum To 1 Step -1
            If mlOsAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar(msOsString(llLoopCnt) & "(" & mlOsAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlOsAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' uEU
    Print #liFileNo, aacAddStartDiv("brws", "uEU")
    If mlBrwsAccess(mlBrwsStrNum) > 0 Then
        ldMaxValue = ciMaxHtmlValue / mlBrwsAccess(mlBrwsStrNum)
        For llLoopCnt = mlBrwsStrNum To 1 Step -1
            If mlBrwsAccess(llLoopCnt) > 0 Then
                Print #liFileNo, aacAddTitleBar(msBrwsString(llLoopCnt) & "(" & mlBrwsAccess(llLoopCnt) & ")", _
                    "<img src=""" & csGifFileName & """ width=""" & Int(mlBrwsAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
            End If
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' G[WFg
    Print #liFileNo, aacAddStartDiv("ob", "G[WFg")
    If mlAgentStrNum > 0 Then
        ldMaxValue = ciMaxHtmlValue / mlAgentAccess(mlAgentStrNum)
        For llLoopCnt = mlAgentStrNum To 1 Step -1
            Print #liFileNo, aacAddTitleBar(msAgentString(llLoopCnt) & "(" & mlAgentAccess(llLoopCnt) & ")", _
                "<img src=""" & csGifFileName & """ width=""" & Int(mlAgentAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' zXg
    Print #liFileNo, aacAddStartDiv("host", "zXg")
    If mlHostStrNum > 0 Then
        ldMaxValue = ciMaxHtmlValue / mlHostAccess(mlHostStrNum)
        For llLoopCnt = mlHostStrNum To 1 Step -1
            Print #liFileNo, aacAddTitleBar(msHostString(llLoopCnt) & "(" & mlHostAccess(llLoopCnt) & ")", _
                "<img src=""" & csGifFileName & """ width=""" & Int(mlHostAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' Oʕ
    Print #liFileNo, aacAddStartDiv("ref", "O")
    If mlRefStrNum > 0 Then
        ldMaxValue = ciMaxHtmlValue / mlRefAccess(mlRefStrNum)
        For llLoopCnt = mlRefStrNum To 1 Step -1
            Print #liFileNo, aacAddTitleBar(msRefString(llLoopCnt) & "(" & mlRefAccess(llLoopCnt) & ")", _
                "<img src=""" & csGifFileName & """ width=""" & Int(mlRefAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    ' y[W
    Print #liFileNo, aacAddStartDiv("page", "y[W")
    If mlPageStrNum > 0 Then
        ldMaxValue = ciMaxHtmlValue / mlPageAccess(mlPageStrNum)
        For llLoopCnt = mlPageStrNum To 1 Step -1
            Print #liFileNo, aacAddTitleBar(msPageString(llLoopCnt) & "(" & mlPageAccess(llLoopCnt) & ")", _
                "<img src=""" & csGifFileName & """ width=""" & Int(mlPageAccess(llLoopCnt) * ldMaxValue) & """ height=""12"" alt=""Bar"">")
        Next llLoopCnt
    End If
    Print #liFileNo, lsEndDiv

    Print #liFileNo, "</body>"
    Print #liFileNo, "</html>"
    Close liFileNo
    aaWriteAccessHtmlFile = True
    Exit Function

aaWriteAccessHtmlFile_Error:
    liRetCode = MsgBox("t@C݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    aaWriteAccessHtmlFile = False
End Function

Private Function aacPutMenuString(ByVal psAncName As String, ByVal psTitle As String) As String
'---------------------------------------------------------------------------
'    : aacPutMenuString()
' @@@\ : j[o͂
' @@ : (I) psAncName      AJ[
'          : (I) psTitle        ږ
'   l : <div> x
' @@ : 2000/03/15
'---------------------------------------------------------------------------
    aacPutMenuString = vbTab & vbTab & "<td><a href=""#" & psAncName & """>" & psTitle & "</a></td>"
End Function

Private Function aacAddStartDiv(ByVal psAncName As String, ByVal psTitle As String) As String
'---------------------------------------------------------------------------
'    : aacAddStartDiv()
' @@@\ : <div>xǉiJnj
' @@ : (I) psAncName      AJ[
'          : (I) psTitle        ږ
'   l : <div> x
' @@ : 2000/03/15
'---------------------------------------------------------------------------
    aacAddStartDiv = "<div>" & vbCrLf & _
        vbTab & "<br>" & vbCrLf & _
        vbTab & "<hr>" & vbCrLf & _
        vbTab & "<a name=""" & psAncName & """>" & "<strong>" & psTitle & "</strong></a><br>"
End Function

'Private Function aacAddEndDiv() As String
''---------------------------------------------------------------------------
''    : aacAddEndDiv()
'' @@@\ : <div>xǉiIj
'' @@ : Ȃ
''   l : <div> x
'' @@ : 2000/03/15
''---------------------------------------------------------------------------
'    aacAddEndDiv = "</div>"
'End Function

Private Function aacAddTitleBar(ByVal psTitle As String, ByVal psBar As String) As String
'---------------------------------------------------------------------------
'    : aacAddTitleBar()
' @@@\ : ڂ\
' @@ : (I) psTitle        ^Cg
'          : (I) psBar          o[̒l
'   l : <td> x
' @@ : 2000/03/15
'---------------------------------------------------------------------------
    aacAddTitleBar = vbTab & psTitle & "<br>" & psBar & "<br>"
End Function

Private Function aacWriteGifFile(ByVal psFolderName As String) As Boolean
'---------------------------------------------------------------------------
'    : aacWriteGifFile()
' @@@\ : 摜t@Co
' @@ : (I) psFolderName   o̓tH_[
'   l : True= , False= s
' @@ : 2000/03/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsFileName      As String           ' t@C
    Dim liRetCode       As Integer          ' ߂l
    Dim lbGifData(91)   As Byte

    On Error GoTo aacWriteGifFile_Error

    lsFileName = psFolderName & csGifFileName
    If Dir(lsFileName, vbNormal) = "" Then
        liFileNo = FreeFile

        Open lsFileName For Binary Access Write As liFileNo
        lbGifData(0) = &H47
        lbGifData(1) = &H49
        lbGifData(2) = &H46
        lbGifData(3) = &H38
        lbGifData(4) = &H39
        lbGifData(5) = &H61
        lbGifData(6) = &H1
        lbGifData(7) = &H0
        lbGifData(8) = &HC
        lbGifData(9) = &H0
        lbGifData(10) = &HB3
        lbGifData(11) = &HFF
        lbGifData(12) = &H0
        lbGifData(13) = &HFF
        lbGifData(14) = &HFF
        lbGifData(15) = &HFF
        lbGifData(16) = &HF6
        lbGifData(17) = &HF6
        lbGifData(18) = &HFF
        lbGifData(19) = &HEB
        lbGifData(20) = &HEC
        lbGifData(21) = &HFF
        lbGifData(22) = &HDD
        lbGifData(23) = &HDE
        lbGifData(24) = &HFF
        lbGifData(25) = &HCE
        lbGifData(26) = &HD0
        lbGifData(27) = &HFF
        lbGifData(28) = &HBF
        lbGifData(29) = &HC2
        lbGifData(30) = &HFF
        lbGifData(31) = &HB1
        lbGifData(32) = &HB4
        lbGifData(33) = &HFF
        lbGifData(34) = &HA4
        lbGifData(35) = &HA7
        lbGifData(36) = &HFF
        lbGifData(37) = &H95
        lbGifData(38) = &H98
        lbGifData(39) = &HFF
        lbGifData(40) = &H86
        lbGifData(41) = &H89
        lbGifData(42) = &HFF
        lbGifData(43) = &H78
        lbGifData(44) = &H7D
        lbGifData(45) = &HFF
        lbGifData(46) = &H6C
        lbGifData(47) = &H71
        lbGifData(48) = &HFF
        lbGifData(49) = &H64
        lbGifData(50) = &H69
        lbGifData(51) = &HFF
        lbGifData(52) = &H0
        lbGifData(53) = &H0
        lbGifData(54) = &H0
        lbGifData(55) = &HC0
        lbGifData(56) = &HC0
        lbGifData(57) = &HC0
        lbGifData(58) = &H0
        lbGifData(59) = &H0
        lbGifData(60) = &H0
        lbGifData(61) = &H21
        lbGifData(62) = &HF9
        lbGifData(63) = &H4
        lbGifData(64) = &H1
        lbGifData(65) = &H0
        lbGifData(66) = &H0
        lbGifData(67) = &HE
        lbGifData(68) = &H0
        lbGifData(69) = &H2C
        lbGifData(70) = &H0
        lbGifData(71) = &H0
        lbGifData(72) = &H0
        lbGifData(73) = &H0
        lbGifData(74) = &H1
        lbGifData(75) = &H0
        lbGifData(76) = &HC
        lbGifData(77) = &H0
        lbGifData(78) = &H40
        lbGifData(79) = &H4
        lbGifData(80) = &H9
        lbGifData(81) = &H90
        lbGifData(82) = &H11
        lbGifData(83) = &HA4
        lbGifData(84) = &H8C
        lbGifData(85) = &H58
        lbGifData(86) = &HE9
        lbGifData(87) = &H94
        lbGifData(88) = &H11
        lbGifData(89) = &H22
        lbGifData(90) = &H0
        lbGifData(91) = &H3B
        Put #liFileNo, , lbGifData
        Close liFileNo
    End If

    aacWriteGifFile = True
    Exit Function

aacWriteGifFile_Error:
    liRetCode = MsgBox("摜t@C݂̏Ɏs܂B" & vbCrLf & lsFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close liFileNo
    aacWriteGifFile = False
End Function
