Attribute VB_Name = "basMain"
Option Explicit

Public Const csCompany          As String = "Whitire Company"

' ʔԍ
Public Const ciBaseWindow       As Integer = 1
Public Const ciMonthWindow      As Integer = 2
Public Const ciDateWindow       As Integer = 4
Public Const ciWWeekWindow      As Integer = 8
Public Const ciDWeekWindow      As Integer = 16
Public Const ciTimeWindow       As Integer = 32
Public Const ciOSWindow         As Integer = 64
Public Const ciBrwsWindow       As Integer = 128
Public Const ciHostWindow       As Integer = 256
Public Const ciRefWindow        As Integer = 512
Public Const ciPageWindow       As Integer = 1024
Public Const ciAgentWindow      As Integer = 2048

Public Enum eiFileExt
    eiFileExtTxt
    eiFileExtCsv
    eiFileExtHtml
End Enum

Public Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Public fMainForm        As frmMain
Public Declare Function ShellExecute Lib "SHELL32" Alias "ShellExecuteA" (ByVal hWnd&, ByVal lpOperation$, ByVal lpFile$, ByVal lpParameters$, ByVal lpDirectory$, ByVal nShowCmd&) As Long
Public Declare Function WinHelp Lib "USER32" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
Public Declare Function SendMessage Lib "USER32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function FindExecutable Lib "SHELL32" Alias "FindExecutableA" (ByVal lpFile$, ByVal lpDirectory$, ByVal lpResult$) As Long
Public Declare Function MoveWindow Lib "USER32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function GetClientRect Lib "USER32" (ByVal hWnd&, lpRect As RECT) As Long

Private Declare Function aa_get_version Lib "acalz.dll" (ByVal psVersion As String) As Long

' p[^
Public Const csInitInfo         As String = "InitInfo"

Private mbInitInfo              As Boolean          ' it@C^WXgj
Private mbDeleteRegs            As Boolean          ' WXg폜tO

Public Property Get aaParamValue(ByVal psParamKey As String) As Variant
'---------------------------------------------------------------------------
'    : aaParamValue()
' @@@\ : p[^l̎擾
' @@ : (I) psParamKey     p[^L[
'   l : p[^l
' @@ : 2000/02/25
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csInitInfo
        aaParamValue = mbInitInfo
    End Select
End Property

Sub Main()
'---------------------------------------------------------------------------
'    : main()
' @@@\ : ANZXO̓C
' @@ : Ȃ
'   l : Ȃ
' @@ : 2000/01/05
'---------------------------------------------------------------------------
    Dim llDllVer            As Long         ' ckk̃o[W
    Dim lsDllVer            As String * 10  ' ckk̐o[W
    Dim lsRegistKey         As String       ' o^ԍ
    Dim liAddYearKey        As Integer      ' ÍL[iNj
    Dim liAddMonthKey       As Integer      ' ÍL[ij
    Dim liAddDayKey         As Integer      ' ÍL[ij

    On Error GoTo main_error

    aaGetOption
    If mbDeleteRegs <> False Then
        aaDeleteRegs
        MsgBox "WXgڂ폜܂B", vbInformation, "WXg폜"
    Else
        lsDllVer = String(10, " ")
        llDllVer = aa_get_version(lsDllVer)
        basParam.aaParamValue(csDllVersion) = RTrim(lsDllVer)

        Set fMainForm = New frmMain
        App.HelpFile = App.Path & "\acalz.hlp"

        Randomize
        If mbInitInfo = False Then
            aaReadIniRegs
            fMainForm.mnuFileRegSave.Enabled = True
            fMainForm.tbToolBar.Buttons("RegSave").Enabled = True
        Else
            aaReadIniFile
            fMainForm.mnuFileRegSave.Enabled = False
            fMainForm.tbToolBar.Buttons("RegSave").Enabled = False
        End If
        aaReadFixedInfo
        If basParam.aaParamValue(csRegistrant) = "" Then
            lsRegistKey = basParam.aaParamValue(csRegistKey)
            If lsRegistKey = "" Then
                'V130-00000-000-0000
                liAddYearKey = Int((9 * Rnd) + 1)
                liAddMonthKey = Int((70 * Rnd) + 10)
                liAddDayKey = Int((50 * Rnd) + 10)
                lsRegistKey = "V" & App.Major & Format(App.Minor, "00") & "-" & _
                                liAddYearKey & liAddMonthKey & liAddDayKey & "-" & _
                                Format(Date, "w") & Format(Date, "yy") + liAddYearKey + 10 & "-" & _
                                Format(Date, "mm") + liAddMonthKey & Format(Date, "dd") + liAddDayKey
                basParam.aaParamValue(csRegistKey) = lsRegistKey
            End If
            frmShare.Show vbModal
        End If

        With fMainForm
            .Width = basParam.aaParamValue(csMainWidth)
            .Height = basParam.aaParamValue(csMainHeight)
            .Show
            If basParam.aaParamValue(csAutoFtp) <> False Then
                frmFtp.cmdConnect_Click
                Unload frmFtp
            End If
            If basParam.aaParamValue(csAutoAnalize) <> False Then
                .mnuEditAnalize_Click 0
            End If
            If basParam.aaParamValue(csAutoMaxSize) <> False Then
                .WindowState = vbMaximized
            End If
            If basParam.aaParamValue(csAutoTile) <> False Then
                .mnuWindowTileHorizontal_Click
            End If
        End With
    End If

    Exit Sub

main_error:
    MsgBox "Error: " & Err.Number & vbCrLf & Err.Description, vbCritical
    Exit Sub
End Sub

Public Function aaGetColor(psBefColor As String)
'---------------------------------------------------------------------------
'    : aaGetColor()
' @@@\ : F񕶎񂩂Fԍ擾
' @@ : (I) psBefColor     ϊF
'   l : F̒l
' @@ : 1998/12/11
'---------------------------------------------------------------------------
    Dim llRed           As Long         ' Fiԁj
    Dim llGreen         As Long         ' Fi΁j
    Dim llBlue          As Long         ' Fij

    llRed = CLng(Mid$(psBefColor, 1, 3))
    llGreen = CLng(Mid$(psBefColor, 4, 3))
    llBlue = CLng(Mid$(psBefColor, 7, 3))

    aaGetColor = RGB(llRed, llGreen, llBlue)
End Function

Public Sub aaGetOption()
'---------------------------------------------------------------------------
'    : aaGetOption()
' @@@\ : R}hCIvV̉
' @@ : Ȃ
'   l : Ȃ
' @@ : 2000/02/25
'---------------------------------------------------------------------------
    Dim liLoopCnt           As Integer      ' [vJE^
    Dim liCmdLen            As Integer      ' R}hC̒
    Dim lsCmdLine           As String       ' R}hC
    Dim lsArgment           As String       ' IvV
    Dim lsChar              As String       ' R}hCiPj

    mbInitInfo = True
    mbDeleteRegs = False
    lsCmdLine = Command() & " "
    liCmdLen = Len(lsCmdLine)

    For liLoopCnt = 1 To liCmdLen
        lsChar = Mid$(lsCmdLine, liLoopCnt, 1)
        If (lsChar = " " Or lsChar = vbTab) Then
            Select Case UCase(lsArgment)
            Case "/USEFILE"
                mbInitInfo = True
            Case "/USEREGS"
                mbInitInfo = False

            Case "/DELREGS"
                mbDeleteRegs = True
            End Select
            lsArgment = ""
        Else
            lsArgment = lsArgment & lsChar
        End If
    Next liLoopCnt
End Sub

Public Sub aaDeleteRegs()
'---------------------------------------------------------------------------
'    : aaDeleteRegs()
' @@@\ : WXg̍폜
' @@ : Ȃ
'   l : Ȃ
' @@ : 2000/02/25
'---------------------------------------------------------------------------
    On Error Resume Next

    DeleteSetting csCompany, App.ProductName
End Sub

Public Function aaWriteRegToFile(psFileName As String) As Boolean
'---------------------------------------------------------------------------
'    : aaWriteRegToFile()
' @@@\ : WXgt@Cɏo͂
' @@ : (I) psFileName     o̓t@C
'   l : True= , False= s
' @@ : 1999/01/27
'---------------------------------------------------------------------------
    Dim liRetCode       As Integer      ' ߂l
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim lsOutputStr     As String       ' o͕
    Dim MySettings      As Variant      ' WXgݒ
    Dim intSettings     As Integer      ' WXg[vJE^

    On Error GoTo aaWriteRegToFile_Error

    liFileNo = FreeFile
    Open psFileName For Output As liFileNo

    Print #liFileNo, "REGEDIT4"
    Print #liFileNo, ""
    Print #liFileNo, "[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\Whitire Company\acalz]"

    MySettings = GetAllSettings(appname:=csCompany, section:=App.ProductName)
    For intSettings = LBound(MySettings, 1) To UBound(MySettings, 1)
        Print #liFileNo, """" & MySettings(intSettings, 0) & """=""" & aaAddBackSlash(MySettings(intSettings, 1)) & """"
    Next intSettings
    Print #liFileNo, ""

    Close #liFileNo
    aaWriteRegToFile = True
    Exit Function

aaWriteRegToFile_Error:
    liRetCode = MsgBox("WXg݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    aaWriteRegToFile = False
End Function

Private Function aaAddBackSlash(ByVal psString As String) As String
'---------------------------------------------------------------------------
'    : aaAddBackSlash()
' @@@\ : obNXbVǉ
' @@ : (I) psString       ϊ镶
'   l : ϊ̕
' @@ : 1999/01/27
'---------------------------------------------------------------------------
    Dim liLoopCnt           As Integer      ' [vJE^
    Dim lsChar              As String * 1   ' 擾iPj
    Dim lsAfterString       As String       ' ϊ㕶

    For liLoopCnt = 1 To Len(psString)
        lsChar = Mid$(psString, liLoopCnt, 1)
        If lsChar = "\" Then
            lsAfterString = lsAfterString & lsChar & lsChar
        Else
            lsAfterString = lsAfterString & lsChar
        End If
    Next liLoopCnt

    aaAddBackSlash = lsAfterString
End Function
