Attribute VB_Name = "basParam"
Option Explicit

' p[^L[
Public Const csDllVersion       As String = "DllVersion"
Public Const csRegistrant       As String = "Registrant"
Public Const csRegistKey        As String = "RegistKey"

Public Const csMainWidth        As String = "MainWidth"
Public Const csMainHeight       As String = "MainHeight"
Public Const csVisibleWindow    As String = "VisibleWindow"
Public Const csMainToolbar      As String = "MainToolbar"

Public Const csLogFile          As String = "LogFile"
Public Const csPage             As String = "Page"
Public Const csSpecifyDate      As String = "SpecifyDate"
Public Const csStartDate        As String = "StartDate"
Public Const csEndDate          As String = "EndDate"
Public Const csSpecifyPage      As String = "SpecifyPage"

Public Const csMaxDisp          As String = "MaxDisp"
Public Const csIgnoreIp         As String = "IgnoreIP"
Public Const csSpecifyClass     As String = "SpecifyClass"
Public Const csCheckLine        As String = "CheckLine"
Public Const csCodeChange       As String = "CodeChange"
Public Const csSmallize         As String = "Smallize"
Public Const csIgnoreIndex      As String = "IgnoreIndex"
Public Const csIgnoreQuestion   As String = "IgnoreQuestion"
Public Const csIgnoreSharp      As String = "IgnoreSharp"
Public Const csIgnorePortNo     As String = "IgnorePortNo"
Public Const csSpecifyHost      As String = "SpecifyHost"
Public Const csIgnoreHost       As String = "IgnoreHost"
Public Const csIgnorePage       As String = "IgnorePage"
Public Const csSearchLike       As String = "SearchLike"
Public Const csAutoFtp          As String = "AutoFtp"
Public Const csAutoAnalize      As String = "AutoAnalize"
Public Const csAutoMaxSize      As String = "AutoMaxSize"
Public Const csAutoTile         As String = "AutoTile"

Public Const csFtpServerName    As String = "FtpServerName"
Public Const csFtpUserName      As String = "FtpUserName"
Public Const csFtpPassword      As String = "FtpPassword"
Public Const csFtpHostDir       As String = "FtpHostDir"
Public Const csFtpLocalDir      As String = "FtpLocalFolder"
Public Const csFtpFileName      As String = "FtpFileName"
Public Const csFtpSavePasswd    As String = "FtpSavePassword"
Public Const csFtpOverwrite     As String = "FtpLogOverwrite"
Public Const csFtpMessage       As String = "FtpMessage"

Public Const csGraphFore        As String = "GraphFore"
Public Const csGraphBack        As String = "GraphBack"
Public Const csGraphMonth       As String = "GraphMonth"
Public Const csGraphWWeek       As String = "GraphWeek"
Public Const csGraphDWeek       As String = "GraphDWeek"
Public Const csGraphDate        As String = "GraphDate"
Public Const csGraphTime        As String = "GraphTime"
Public Const csGraphOS          As String = "GraphOS"
Public Const csGraphBrws        As String = "GraphBrws"
Public Const csGraphHost        As String = "GraphHost"
Public Const csGraphRef         As String = "GraphRef"
Public Const csGraphPage        As String = "GraphPage"
Public Const csGraphAgent       As String = "GraphAgent"

Public Const csFontName        As String = "FontName"
Public Const csFontSize        As String = "FontSize"

Public Const csGraphPattern    As String = "GraphPattern"

Public Const csPrintWindow     As String = "PrintWindow"
Public Const csPaperType       As String = "PaperType"

' ftHgl
Public Const ciDefMaxLogFile    As Integer = 5
Public Const ciDefMaxPage       As Integer = 10
Private Const ciDefMaxDisp      As Integer = 25
Private Const clDefCheckLine    As Integer = 200
Private Const ciDefVisWindow    As Integer = 4095
Private Const csDefLogFileName  As String = "access.log"
Private Const csDefPage         As String = "index"
Private Const csDefFtpHostDir   As String = "~/public_html"
Private Const csDefGraphFore    As String = "000000000"
Private Const csDefGraphBack    As String = "255255255"
Private Const csDefGraphMonth   As String = "255000000"
Private Const csDefGraphWWeek   As String = "255128128"
Private Const csDefGraphDWeek   As String = "255128064"
Private Const csDefGraphDate    As String = "235225115"
Private Const csDefGraphTime    As String = "000255064"
Private Const csDefGraphOS      As String = "000255255"
Private Const csDefGraphBrws    As String = "000128255"
Private Const csDefGraphHost    As String = "000032128"
Private Const csDefGraphRef     As String = "128000128"
Private Const csDefGraphPage    As String = "255128255"
Private Const csDefGraphAgent   As String = "255064128"
Private Const csDefFontName     As String = "lr oSVbN"
Private Const ciDefFontSize     As Integer = 9
Private Const ciDefGraphPattern As Integer = 1

' o[
Private msDllVersion        As String       ' ckk̃o[W
Private msRegistrant        As String       ' o^Җ
Private msRegistKey         As String       ' o^L[

Private mlMainWidth         As Long         ' CEBhE
Private mlMainHeight        As Long         ' CEBhE
Private miVisibleWindow     As Integer      ' EBhE\
Private mbMainToolbar       As Boolean      ' c[o[\tO

Private msLogFile(ciDefMaxLogFile)  As String   ' Ot@C
Private msPage(ciDefMaxPage)    As String       ' ̓y[W
Private mbSpecifyDate       As Boolean      ' tw̗L
Private mdStartDate         As Date         ' Jnt
Private mdEndDate           As Date         ' It
Private mbSpecifyPage       As Boolean      ' y[Ww̗L

Private miMaxDisp           As Integer      ' ő\
Private mbIgnoreIp          As Boolean      ' hoAhX𖳎
Private mbSpecifyClass      As Boolean      ' NX̗L
Private mlCheckLine         As Long         ' `FbNs̒P
Private mbCodeChange        As Boolean      ' R[hϊ̗L
Private mbSmallize          As Boolean      ' ɕϊ
Private mbIgnoreIndex       As Boolean      ' index.html 𖳎
Private mbIgnoreQuestion    As Boolean      ' wHx𖳎
Private mbIgnoreSharp       As Boolean      ' wx𖳎
Private mbIgnorePortNo      As Boolean      ' |[gԍ𖳎
Private mbSpecifyHost       As Boolean      ' zXgw肷
Private mbIgnoreHost        As Boolean      ' zXg𖳎
Private mbIgnorePage        As Boolean      ' y[Wʉ͂œt𖳎
Private mbSearchLike        As Boolean      ' k
Private mbAutoFtp           As Boolean      ' グesotO
Private mbAutoAnalize       As Boolean      ' グ̓tO
Private mbAutoMaxSize       As Boolean      ' グő剻tO
Private mbAutoTile          As Boolean      ' グׂtO

Private msFtpServerName     As String       ' T[o[
Private msFtpUserName       As String       ' [U[
Private msFtpPassword       As String       ' pX[h
Private msFtpHostDir        As String       ' zXgfBNg
Private msFtpLocalDir       As String       ' [JtH_[
Private msFtpFileName       As String       ' Ot@C
Private mbFtpSavePasswd     As Boolean      ' pX[h̕ۑݒ
Private mbFtpOverwrite      As Boolean      ' Ot@C̏㏑mF
Private mbFtpMessage        As Boolean      ' IbZ[W\I^It

Private msGraphFore         As String       ' OtFiOiFj
Private msGraphBack         As String       ' OtFiwiFj
Private msGraphMonth        As String       ' OtFiFj
Private msGraphWWeek        As String       ' OtFiTFj
Private msGraphDWeek        As String       ' OtFijFj
Private msGraphDate         As String       ' OtFitFj
Private msGraphTime         As String       ' OtFiԐFj
Private msGraphOS           As String       ' OtFinrFj
Private msGraphBrws         As String       ' OtFiuEUFj
Private msGraphHost         As String       ' OtFizXgFj
Private msGraphRef          As String       ' OtFiOtqkFj
Private msGraphPage         As String       ' OtFiy[WFj
Private msGraphAgent        As String       ' OtFiG[WFgFj

Private msFontName          As String       ' tHg
Private miFontSize          As Integer      ' tHgTCY
Private miGraphPattern      As Integer      ' Otp^[

Private miPrintWindow       As Integer      ' 
Private miPaperType         As Integer      ' p^Cv

Public Property Get aaParamValue(ByVal psParamKey As String, Optional ByVal plIndex As Long) As Variant
'---------------------------------------------------------------------------
'    : aaParamValue()
' @@@\ : p[^l̎擾
' @@ : (I) psParamKey     p[^L[
'   l : p[^l
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csLogFile
        aaParamValue = msLogFile(plIndex)
    Case csPage
        aaParamValue = msPage(plIndex)
    Case csSpecifyDate
        aaParamValue = mbSpecifyDate
    Case csStartDate
        aaParamValue = mdStartDate
    Case csEndDate
        aaParamValue = mdEndDate
    Case csSpecifyPage
        aaParamValue = mbSpecifyPage

    Case csMaxDisp
        aaParamValue = miMaxDisp
    Case csIgnoreIp
        aaParamValue = mbIgnoreIp
    Case csSpecifyClass
        aaParamValue = mbSpecifyClass
    Case csCheckLine
        aaParamValue = mlCheckLine
    Case csCodeChange
        aaParamValue = mbCodeChange
    Case csSmallize
        aaParamValue = mbSmallize
    Case csIgnoreIndex
        aaParamValue = mbIgnoreIndex
    Case csIgnoreQuestion
        aaParamValue = mbIgnoreQuestion
    Case csIgnoreSharp
        aaParamValue = mbIgnoreSharp
    Case csIgnorePortNo
        aaParamValue = mbIgnorePortNo
    Case csSpecifyHost
        aaParamValue = mbSpecifyHost
    Case csIgnoreHost
        aaParamValue = mbIgnoreHost
    Case csIgnorePage
        aaParamValue = mbIgnorePage
    Case csSearchLike
        aaParamValue = mbSearchLike
    Case csAutoFtp
        aaParamValue = mbAutoFtp
    Case csAutoAnalize
        aaParamValue = mbAutoAnalize
    Case csAutoMaxSize
        aaParamValue = mbAutoMaxSize
    Case csAutoTile
        aaParamValue = mbAutoTile

    Case csFtpServerName
        aaParamValue = msFtpServerName
    Case csFtpUserName
        aaParamValue = msFtpUserName
    Case csFtpPassword
        aaParamValue = msFtpPassword
    Case csFtpHostDir
        aaParamValue = msFtpHostDir
    Case csFtpLocalDir
        aaParamValue = msFtpLocalDir
    Case csFtpFileName
        aaParamValue = msFtpFileName
    Case csFtpSavePasswd
        aaParamValue = mbFtpSavePasswd
    Case csFtpOverwrite
        aaParamValue = mbFtpOverwrite
    Case csFtpMessage
        aaParamValue = mbFtpMessage

    Case csGraphFore
        aaParamValue = msGraphFore
    Case csGraphBack
        aaParamValue = msGraphBack
    Case csGraphMonth
        aaParamValue = msGraphMonth
    Case csGraphWWeek
        aaParamValue = msGraphWWeek
    Case csGraphDWeek
        aaParamValue = msGraphDWeek
    Case csGraphDate
        aaParamValue = msGraphDate
    Case csGraphTime
        aaParamValue = msGraphTime
    Case csGraphOS
        aaParamValue = msGraphOS
    Case csGraphBrws
        aaParamValue = msGraphBrws
    Case csGraphHost
        aaParamValue = msGraphHost
    Case csGraphRef
        aaParamValue = msGraphRef
    Case csGraphPage
        aaParamValue = msGraphPage
    Case csGraphAgent
        aaParamValue = msGraphAgent

    Case csFontName
        aaParamValue = msFontName
    Case csFontSize
        aaParamValue = miFontSize

    Case csGraphPattern
        aaParamValue = miGraphPattern

    Case csPrintWindow
        aaParamValue = miPrintWindow
    Case csPaperType
        aaParamValue = miPaperType

    Case csDllVersion
        aaParamValue = msDllVersion
    Case csRegistrant
        aaParamValue = msRegistrant
    Case csRegistKey
        aaParamValue = msRegistKey

    Case csMainWidth
        aaParamValue = mlMainWidth
    Case csMainHeight
        aaParamValue = mlMainHeight
    Case csVisibleWindow
        aaParamValue = miVisibleWindow
    Case csMainToolbar
        aaParamValue = mbMainToolbar

    End Select
End Property

Public Property Let aaParamValue(ByVal psParamKey As String, Optional ByVal plIndex As Long, ByVal pvParamValue As Variant)
'---------------------------------------------------------------------------
'    : aaParamValue()
' @@@\ : p[^l̐ݒ
' @@ : (I) psParamKey     p[^L[
'          : (I) pvParamValue   p[^l
'   l : Ȃ
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim llLoopCnt           As Long         ' [vJE^
    Dim llNewCnt            As Long         ' Vf[^
    Dim lsLogFile(ciDefMaxLogFile)  As String       ' Ot@C
    Dim lsPage(ciDefMaxPage)    As String   ' ̓y[W

    Select Case psParamKey
    Case csLogFile
        For llLoopCnt = 1 To ciDefMaxLogFile
            If pvParamValue <> msLogFile(llLoopCnt) Then
                llNewCnt = llNewCnt + 1
                lsLogFile(llNewCnt) = msLogFile(llLoopCnt)
            End If
        Next llLoopCnt
        If llNewCnt > ciDefMaxLogFile - 1 Then
            llNewCnt = ciDefMaxLogFile - 1
        End If
        msLogFile(1) = pvParamValue
        For llLoopCnt = 1 To llNewCnt
            msLogFile(llLoopCnt + 1) = lsLogFile(llLoopCnt)
        Next llLoopCnt
    Case csPage
        For llLoopCnt = 1 To ciDefMaxPage
            If pvParamValue <> msPage(llLoopCnt) Then
                llNewCnt = llNewCnt + 1
                lsPage(llNewCnt) = msPage(llLoopCnt)
            End If
        Next llLoopCnt
        If llNewCnt > ciDefMaxPage - 1 Then
            llNewCnt = ciDefMaxPage - 1
        End If
        msPage(1) = pvParamValue
        For llLoopCnt = 1 To llNewCnt
            msPage(llLoopCnt + 1) = lsPage(llLoopCnt)
        Next llLoopCnt
    Case csSpecifyDate
        mbSpecifyDate = pvParamValue
    Case csStartDate
        mdStartDate = pvParamValue
    Case csEndDate
        mdEndDate = pvParamValue
    Case csSpecifyPage
        mbSpecifyPage = pvParamValue

    Case csMaxDisp
        miMaxDisp = pvParamValue
    Case csIgnoreIp
        mbIgnoreIp = pvParamValue
    Case csSpecifyClass
        mbSpecifyClass = pvParamValue
    Case csCheckLine
        mlCheckLine = pvParamValue
    Case csCodeChange
        mbCodeChange = pvParamValue
    Case csSmallize
        mbSmallize = pvParamValue
    Case csIgnoreIndex
        mbIgnoreIndex = pvParamValue
    Case csIgnoreQuestion
        mbIgnoreQuestion = pvParamValue
    Case csIgnoreSharp
        mbIgnoreSharp = pvParamValue
    Case csIgnorePortNo
        mbIgnorePortNo = pvParamValue
    Case csSpecifyHost
        mbSpecifyHost = pvParamValue
    Case csIgnoreHost
        mbIgnoreHost = pvParamValue
    Case csIgnorePage
        mbIgnorePage = pvParamValue
    Case csSearchLike
        mbSearchLike = pvParamValue
    Case csAutoFtp
        mbAutoFtp = pvParamValue
    Case csAutoAnalize
        mbAutoAnalize = pvParamValue
    Case csAutoMaxSize
        mbAutoMaxSize = pvParamValue
    Case csAutoTile
        mbAutoTile = pvParamValue

    Case csFtpServerName
        msFtpServerName = pvParamValue
    Case csFtpUserName
        msFtpUserName = pvParamValue
    Case csFtpPassword
        msFtpPassword = pvParamValue
    Case csFtpHostDir
        msFtpHostDir = pvParamValue
    Case csFtpLocalDir
        msFtpLocalDir = pvParamValue
    Case csFtpFileName
        msFtpFileName = pvParamValue
    Case csFtpSavePasswd
        mbFtpSavePasswd = pvParamValue
    Case csFtpOverwrite
        mbFtpOverwrite = pvParamValue
    Case csFtpMessage
        mbFtpMessage = pvParamValue

    Case csGraphFore
        msGraphFore = pvParamValue
    Case csGraphBack
        msGraphBack = pvParamValue
    Case csGraphMonth
        msGraphMonth = pvParamValue
    Case csGraphWWeek
        msGraphWWeek = pvParamValue
    Case csGraphDWeek
        msGraphDWeek = pvParamValue
    Case csGraphDate
        msGraphDate = pvParamValue
    Case csGraphTime
        msGraphTime = pvParamValue
    Case csGraphOS
        msGraphOS = pvParamValue
    Case csGraphBrws
        msGraphBrws = pvParamValue
    Case csGraphHost
        msGraphHost = pvParamValue
    Case csGraphRef
        msGraphRef = pvParamValue
    Case csGraphPage
        msGraphPage = pvParamValue
    Case csGraphAgent
        msGraphAgent = pvParamValue

    Case csFontName
        msFontName = pvParamValue
    Case csFontSize
        miFontSize = pvParamValue

    Case csGraphPattern
        miGraphPattern = pvParamValue

    Case csPrintWindow
        miPrintWindow = pvParamValue
    Case csPaperType
        miPaperType = pvParamValue

    Case csDllVersion
        msDllVersion = pvParamValue
    Case csRegistrant
        msRegistrant = pvParamValue
    Case csRegistKey
        msRegistKey = pvParamValue

    Case csMainWidth
        mlMainWidth = pvParamValue
    Case csMainHeight
        mlMainHeight = pvParamValue
    Case csVisibleWindow
        miVisibleWindow = pvParamValue
    Case csMainToolbar
        mbMainToolbar = pvParamValue

    End Select
End Property

Public Function aaReadIniFile() As Boolean
'---------------------------------------------------------------------------
'    : aaReadIniFile()
' @@@\ : p[^t@Cǂݍ
' @@ : Ȃ
'   l : True= , False= s
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim liLoopCnt       As Integer          ' [vJE^
    Dim lsFileName      As String           ' t@C
    Dim lsLine          As String           ' ǂݍݕ
    Dim lsKeyStr        As String           ' p[^L[
    Dim liEqlPos        As Integer          ' ̈ʒu
    Dim lsPrmStr        As String           ' p[^l
    Dim liLogCnt        As Integer          ' Ot@Ci[ʒu
    Dim liPageCnt       As Integer          ' ̓y[Wi[ʒu
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo aaReadIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".ini"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    mlMainWidth = 8400
    mlMainHeight = 5865
    miVisibleWindow = ciDefVisWindow
    mbMainToolbar = True

    mbSpecifyDate = True
    mdStartDate = Format(Date, "YYYY/MM/") & "01"
    mdEndDate = Format(Date, "YYYY/MM/DD")
    mbSpecifyPage = True
    liLogCnt = 0
    liPageCnt = 0
    msLogFile(1) = App.Path & "\" & csDefLogFileName
    msPage(1) = csDefPage

    miMaxDisp = ciDefMaxDisp
    mbIgnoreIp = False
    mbSpecifyClass = True
    mlCheckLine = clDefCheckLine
    mbCodeChange = True
    mbSmallize = False
    mbIgnoreIndex = True
    mbIgnoreQuestion = True
    mbIgnoreSharp = True
    mbIgnorePortNo = True
    mbSpecifyHost = False
    mbIgnoreHost = False
    mbIgnorePage = True
    mbSearchLike = False
    mbAutoFtp = False
    mbAutoAnalize = False
    mbAutoMaxSize = False
    mbAutoTile = False

    msFtpHostDir = csDefFtpHostDir
    msFtpLocalDir = App.Path
    msFtpFileName = csDefLogFileName
    mbFtpMessage = True
    mbFtpOverwrite = True

    msGraphFore = csDefGraphFore
    msGraphBack = csDefGraphBack
    msGraphMonth = csDefGraphMonth
    msGraphWWeek = csDefGraphWWeek
    msGraphDWeek = csDefGraphDWeek
    msGraphDate = csDefGraphDate
    msGraphTime = csDefGraphTime
    msGraphOS = csDefGraphOS
    msGraphBrws = csDefGraphBrws
    msGraphHost = csDefGraphHost
    msGraphRef = csDefGraphRef
    msGraphPage = csDefGraphPage
    msGraphAgent = csDefGraphAgent

    msFontName = csDefFontName
    miFontSize = ciDefFontSize
    miGraphPattern = ciDefGraphPattern

    miPrintWindow = ciDefVisWindow
    miPaperType = 0

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Left$(lsLine, liEqlPos - 1)
            lsPrmStr = Mid$(lsLine, liEqlPos + 1)

            Select Case UCase(Trim(lsKeyStr))
            Case UCase(csRegistrant)
                msRegistrant = lsPrmStr

            Case UCase(csRegistKey)
                msRegistKey = lsPrmStr

            Case UCase(csMainWidth)
                mlMainWidth = Abs(CLng(lsPrmStr))

            Case UCase(csMainHeight)
                mlMainHeight = Abs(CLng(lsPrmStr))

            Case UCase(csVisibleWindow)
                miVisibleWindow = CInt(lsPrmStr)
                If miVisibleWindow < 0 Or miVisibleWindow > ciDefVisWindow Then
                    miVisibleWindow = ciDefVisWindow
                End If

            Case UCase(csMainToolbar)
                mbMainToolbar = CBool(lsPrmStr)

            Case UCase(csLogFile)
                liLogCnt = liLogCnt + 1
                If liLogCnt <= ciDefMaxLogFile Then
                    msLogFile(liLogCnt) = Trim(lsPrmStr)
                End If

            Case UCase(csPage)
                liPageCnt = liPageCnt + 1
                If liPageCnt <= ciDefMaxPage Then
                    msPage(liPageCnt) = Trim(lsPrmStr)
                End If

            Case UCase(csSpecifyDate)
                mbSpecifyDate = CBool(lsPrmStr)

            Case UCase(csStartDate)
                mdStartDate = Trim(lsPrmStr)

            Case UCase(csEndDate)
                mdEndDate = Trim(lsPrmStr)

            Case UCase(csSpecifyPage)
                mbSpecifyPage = CBool(lsPrmStr)

            Case UCase(csMaxDisp)
                miMaxDisp = CInt(lsPrmStr)
                If miMaxDisp < 1 Or miMaxDisp > 999 Then
                    miMaxDisp = ciDefMaxDisp
                End If

            Case UCase(csIgnoreIp)
                mbIgnoreIp = CBool(lsPrmStr)

            Case UCase(csSpecifyClass)
                mbSpecifyClass = CBool(lsPrmStr)

            Case UCase(csCheckLine)
                mlCheckLine = CLng(lsPrmStr)
                If mlCheckLine < clDefCheckLine Then
                    mlCheckLine = clDefCheckLine
                End If

            Case UCase(csCodeChange)
                mbCodeChange = CBool(lsPrmStr)

            Case UCase(csSmallize)
                mbSmallize = CBool(lsPrmStr)

            Case UCase(csIgnoreIndex)
                mbIgnoreIndex = CBool(lsPrmStr)

            Case UCase(csIgnoreQuestion)
                mbIgnoreQuestion = CBool(lsPrmStr)

            Case UCase(csIgnoreSharp)
                mbIgnoreSharp = CBool(lsPrmStr)

            Case UCase(csIgnorePortNo)
                mbIgnorePortNo = CBool(lsPrmStr)

            Case UCase(csSpecifyHost)
                mbSpecifyHost = CBool(lsPrmStr)

            Case UCase(csIgnoreHost)
                mbIgnoreHost = CBool(lsPrmStr)

            Case UCase(csIgnorePage)
                mbIgnorePage = CBool(lsPrmStr)

            Case UCase(csSearchLike)
                mbSearchLike = CBool(lsPrmStr)

            Case UCase(csAutoFtp)
                mbAutoFtp = CBool(lsPrmStr)

            Case UCase(csAutoAnalize)
                mbAutoAnalize = CBool(lsPrmStr)

            Case UCase(csAutoMaxSize)
                mbAutoMaxSize = CBool(lsPrmStr)

            Case UCase(csAutoTile)
                mbAutoTile = CBool(lsPrmStr)

            Case UCase(csFtpServerName)
                msFtpServerName = Trim(lsPrmStr)

            Case UCase(csFtpUserName)
                msFtpUserName = Trim(lsPrmStr)

            Case UCase(csFtpPassword)
                msFtpPassword = Trim(lsPrmStr)
                If Len(msFtpPassword) = 60 Then
                    msFtpPassword = aaDecPassword(msFtpPassword)
                    If msFtpPassword <> "" Then
                        mbFtpSavePasswd = True
                    Else
                        mbFtpSavePasswd = False
                    End If
                Else
                    msFtpPassword = ""
                    mbFtpSavePasswd = False
                End If

            Case UCase(csFtpOverwrite)
                mbFtpOverwrite = CBool(lsPrmStr)

            Case UCase(csFtpMessage)
                mbFtpMessage = CBool(lsPrmStr)

            Case UCase(csFtpHostDir)
                msFtpHostDir = Trim(lsPrmStr)

            Case UCase(csFtpLocalDir)
                msFtpLocalDir = Trim(lsPrmStr)

            Case UCase(csFtpFileName)
                msFtpFileName = Trim(lsPrmStr)

            Case UCase(csGraphFore)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphFore = Trim(lsPrmStr)
                End If

            Case UCase(csGraphBack)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphBack = Trim(lsPrmStr)
                End If

            Case UCase(csGraphMonth)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphMonth = Trim(lsPrmStr)
                End If

            Case UCase(csGraphWWeek)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphWWeek = Trim(lsPrmStr)
                End If

            Case UCase(csGraphDWeek)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphDWeek = Trim(lsPrmStr)
                End If

            Case UCase(csGraphDate)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphDate = Trim(lsPrmStr)
                End If

            Case UCase(csGraphTime)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphTime = Trim(lsPrmStr)
                End If

            Case UCase(csGraphOS)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphOS = Trim(lsPrmStr)
                End If

            Case UCase(csGraphBrws)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphBrws = Trim(lsPrmStr)
                End If

            Case UCase(csGraphHost)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphHost = Trim(lsPrmStr)
                End If

            Case UCase(csGraphRef)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphRef = Trim(lsPrmStr)
                End If

            Case UCase(csGraphPage)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphPage = Trim(lsPrmStr)
                End If

            Case UCase(csGraphAgent)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphAgent = Trim(lsPrmStr)
                End If

            Case UCase(csFontName)
                msFontName = Trim(lsPrmStr)

            Case UCase(csFontSize)
                miFontSize = CInt(lsPrmStr)
                If miFontSize < 1 Or miFontSize > 99 Then
                    miFontSize = ciDefFontSize
                End If

            Case UCase(csGraphPattern)
                miGraphPattern = CInt(lsPrmStr)
                If miGraphPattern < 0 Or miGraphPattern > 7 Then
                    miGraphPattern = ciDefGraphPattern
                End If

            Case UCase(csPrintWindow)
                miPrintWindow = CInt(lsPrmStr)
                If miPrintWindow < 0 Or miPrintWindow > ciDefVisWindow Then
                    miPrintWindow = ciDefVisWindow
                End If

            Case UCase(csPaperType)
                miPaperType = CInt(lsPrmStr)
                If miPaperType < 0 Or miPaperType > 2 Then
                    miPaperType = 0
                End If

            End Select
        End If
    Loop

    Close liFileNo
    aaReadIniFile = True
    Exit Function

aaReadIniFile_Error:
    Close liFileNo
    aaReadIniFile = False
End Function

Public Function aaWriteIniFile() As Boolean
'---------------------------------------------------------------------------
'    : aaWriteIniFile()
' @@@\ : ݒt@C̏
' @@ : Ȃ
'   l : True= , False= s
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsIniFile       As String           ' ݒt@C
    Dim liRetCode       As Integer          ' ߂l
    Dim liLoopCnt       As Integer          ' [vJE^
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo aaWriteIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsIniFile = lsAppPath & App.ProductName & ".ini"
    Else
        lsIniFile = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    Open lsIniFile For Output Access Write As liFileNo
    Print #liFileNo, "[" & App.ProductName & "]"
    Print #liFileNo, ""

    If msRegistrant <> "" Then
        Print #liFileNo, csRegistrant & "=" & msRegistrant
    End If
    If msRegistKey <> "" Then
        Print #liFileNo, csRegistKey & "=" & msRegistKey
    End If

    Print #liFileNo, csMainWidth & "=" & mlMainWidth
    Print #liFileNo, csMainHeight & "=" & mlMainHeight
    If miVisibleWindow <> ciDefVisWindow Then
        Print #liFileNo, csVisibleWindow & "=" & miVisibleWindow
    End If
    If mbMainToolbar <> True Then
        Print #liFileNo, csMainToolbar & "=" & mbMainToolbar
    End If

    For liLoopCnt = 1 To ciDefMaxLogFile
        If msLogFile(liLoopCnt) <> "" Then
            Print #liFileNo, csLogFile & "=" & msLogFile(liLoopCnt)
        End If
    Next liLoopCnt
    For liLoopCnt = 1 To ciDefMaxPage
        If msPage(liLoopCnt) <> "" Then
            Print #liFileNo, csPage & "=" & msPage(liLoopCnt)
        End If
    Next liLoopCnt
    If mbSpecifyDate <> True Then
        Print #liFileNo, csSpecifyDate & "=" & mbSpecifyDate
    End If
    Print #liFileNo, csStartDate & "=" & Format(mdStartDate, "yyyy/m/d")
    Print #liFileNo, csEndDate & "=" & Format(mdEndDate, "yyyy/m/d")
    If mbSpecifyPage <> True Then
        Print #liFileNo, csSpecifyPage & "=" & mbSpecifyPage
    End If

    If miMaxDisp <> ciDefMaxDisp Then
        Print #liFileNo, csMaxDisp & "=" & miMaxDisp
    End If
    If mbIgnoreIp <> False Then
        Print #liFileNo, csIgnoreIp & "=" & mbIgnoreIp
    End If
    If mbSpecifyClass = False Then
        Print #liFileNo, csSpecifyClass & "=" & mbSpecifyClass
    End If
    If mlCheckLine <> clDefCheckLine Then
        Print #liFileNo, csCheckLine & "=" & mlCheckLine
    End If
    If mbCodeChange <> True Then
        Print #liFileNo, csCodeChange & "=" & mbCodeChange
    End If
    If mbSmallize <> False Then
        Print #liFileNo, csSmallize & "=" & mbSmallize
    End If
    If mbIgnoreIndex <> True Then
        Print #liFileNo, csIgnoreIndex & "=" & mbIgnoreIndex
    End If
    If mbIgnoreQuestion <> True Then
        Print #liFileNo, csIgnoreQuestion & "=" & mbIgnoreQuestion
    End If
    If mbIgnoreSharp <> True Then
        Print #liFileNo, csIgnoreSharp & "=" & mbIgnoreSharp
    End If
    If mbIgnorePortNo <> True Then
        Print #liFileNo, csIgnorePortNo & "=" & mbIgnorePortNo
    End If
    If mbSpecifyHost <> False Then
        Print #liFileNo, csSpecifyHost & "=" & mbSpecifyHost
    End If
    If mbIgnoreHost <> False Then
        Print #liFileNo, csIgnoreHost & "=" & mbIgnoreHost
    End If
    If mbIgnorePage <> True Then
        Print #liFileNo, csIgnorePage & "=" & mbIgnorePage
    End If
    If mbSearchLike <> False Then
        Print #liFileNo, csSearchLike & "=" & mbSearchLike
    End If
    If mbAutoFtp <> False Then
        Print #liFileNo, csAutoFtp & "=" & mbAutoFtp
    End If
    If mbAutoAnalize <> False Then
        Print #liFileNo, csAutoAnalize & "=" & mbAutoAnalize
    End If
    If mbAutoMaxSize <> False Then
        Print #liFileNo, csAutoMaxSize & "=" & mbAutoMaxSize
    End If
    If mbAutoTile <> False Then
        Print #liFileNo, csAutoTile & "=" & mbAutoTile
    End If

    If msFtpServerName <> "" Then
        Print #liFileNo, csFtpServerName & "=" & msFtpServerName
    End If
    If msFtpUserName <> "" Then
        Print #liFileNo, csFtpUserName & "=" & msFtpUserName
    End If
    If mbFtpSavePasswd <> False Then
        Print #liFileNo, csFtpPassword & "=" & aaEncPassword(msFtpPassword)
    End If
    If mbFtpOverwrite <> True Then
        Print #liFileNo, csFtpOverwrite & "=" & mbFtpOverwrite
    End If
    If mbFtpMessage <> True Then
        Print #liFileNo, csFtpMessage & "=" & mbFtpMessage
    End If
    If msFtpHostDir <> csDefFtpHostDir Then
        Print #liFileNo, csFtpHostDir & "=" & msFtpHostDir
    End If
    Print #liFileNo, csFtpLocalDir & "=" & msFtpLocalDir
    If msFtpFileName <> csDefLogFileName Then
        Print #liFileNo, csFtpFileName & "=" & msFtpFileName
    End If

    If msGraphFore <> csDefGraphFore Then
        Print #liFileNo, csGraphFore & "=" & msGraphFore
    End If
    If msGraphBack <> csDefGraphBack Then
        Print #liFileNo, csGraphBack & "=" & msGraphBack
    End If
    If msGraphMonth <> csDefGraphMonth Then
        Print #liFileNo, csGraphMonth & "=" & msGraphMonth
    End If
    If msGraphWWeek <> csDefGraphWWeek Then
        Print #liFileNo, csGraphWWeek & "=" & msGraphWWeek
    End If
    If msGraphDWeek <> csDefGraphDWeek Then
        Print #liFileNo, csGraphDWeek & "=" & msGraphDWeek
    End If
    If msGraphDate <> csDefGraphDate Then
        Print #liFileNo, csGraphDate & "=" & msGraphDate
    End If
    If msGraphTime <> csDefGraphTime Then
        Print #liFileNo, csGraphTime & "=" & msGraphTime
    End If
    If msGraphOS <> csDefGraphOS Then
        Print #liFileNo, csGraphOS & "=" & msGraphOS
    End If
    If msGraphBrws <> csDefGraphBrws Then
        Print #liFileNo, csGraphBrws & "=" & msGraphBrws
    End If
    If msGraphHost <> csDefGraphHost Then
        Print #liFileNo, csGraphHost & "=" & msGraphHost
    End If
    If msGraphRef <> csDefGraphRef Then
        Print #liFileNo, csGraphRef & "=" & msGraphRef
    End If
    If msGraphPage <> csDefGraphPage Then
        Print #liFileNo, csGraphPage & "=" & msGraphPage
    End If
    If msGraphAgent <> csDefGraphAgent Then
        Print #liFileNo, csGraphAgent & "=" & msGraphAgent
    End If

    If msFontName <> csDefFontName Then
        Print #liFileNo, csFontName & "=" & msFontName
    End If
    If miFontSize <> ciDefFontSize Then
        Print #liFileNo, csFontSize & "=" & miFontSize
    End If

    If miGraphPattern <> ciDefGraphPattern Then
        Print #liFileNo, csGraphPattern & "=" & miGraphPattern
    End If

    If miPrintWindow <> ciDefVisWindow Then
        Print #liFileNo, csPrintWindow & "=" & miPrintWindow
    End If
    If miPaperType <> 0 Then
        Print #liFileNo, csPaperType & "=" & miPaperType
    End If

    Close liFileNo
    aaWriteIniFile = True
    Exit Function

aaWriteIniFile_Error:
    liRetCode = MsgBox("ݒt@C݂̏Ɏs܂B" & vbCrLf & lsIniFile, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    aaWriteIniFile = False
End Function

Public Function aaReadIniRegs() As Boolean
'---------------------------------------------------------------------------
'    : aaReadIniRegs()
' @@@\ : p[^t@Cǂݍ
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2000/02/25
'---------------------------------------------------------------------------
    Dim lsProductName   As String           ' v_Ng
    Dim lsColorValue    As String           ' F
    Dim liLoopCnt       As Integer          ' [vJE^

    On Error Resume Next
    lsProductName = App.ProductName

    msRegistrant = GetSetting(csCompany, lsProductName, csRegistrant, "")
    msRegistKey = GetSetting(csCompany, lsProductName, csRegistKey, "")

    mlMainWidth = GetSetting(csCompany, lsProductName, csMainWidth, 8400)
    mlMainHeight = GetSetting(csCompany, lsProductName, csMainHeight, 5865)

    miVisibleWindow = GetSetting(csCompany, lsProductName, csVisibleWindow, ciDefVisWindow)
    If miVisibleWindow < 0 Or miVisibleWindow > ciDefVisWindow Then
        miVisibleWindow = ciDefVisWindow
    End If
    mbMainToolbar = GetSetting(csCompany, lsProductName, csMainToolbar, True)
    For liLoopCnt = 1 To ciDefMaxLogFile
        If liLoopCnt = 1 Then
            msLogFile(liLoopCnt) = GetSetting(csCompany, lsProductName, csLogFile & liLoopCnt, App.Path & "\" & csDefLogFileName)
        Else
            msLogFile(liLoopCnt) = GetSetting(csCompany, lsProductName, csLogFile & liLoopCnt, "")
        End If
    Next liLoopCnt
    For liLoopCnt = 1 To ciDefMaxPage
        If liLoopCnt = 1 Then
            msPage(liLoopCnt) = GetSetting(csCompany, lsProductName, csPage & liLoopCnt, csDefPage)
        Else
            msPage(liLoopCnt) = GetSetting(csCompany, lsProductName, csPage & liLoopCnt, "")
        End If
    Next liLoopCnt
    mbSpecifyDate = GetSetting(csCompany, lsProductName, csSpecifyDate, True)
    mdStartDate = GetSetting(csCompany, lsProductName, csStartDate, Format(Date, "YYYY/MM/") & "01")
    mdEndDate = GetSetting(csCompany, lsProductName, csEndDate, Format(Date, "YYYY/MM/DD"))
    mbSpecifyPage = GetSetting(csCompany, lsProductName, csSpecifyPage, True)

    miMaxDisp = GetSetting(csCompany, lsProductName, csMaxDisp, ciDefMaxDisp)
    If miMaxDisp < 1 Or miMaxDisp > 999 Then
        miMaxDisp = ciDefMaxDisp
    End If
    mbIgnoreIp = GetSetting(csCompany, lsProductName, csIgnoreIp, False)
    mbSpecifyClass = GetSetting(csCompany, lsProductName, csSpecifyClass, True)
    mlCheckLine = GetSetting(csCompany, lsProductName, csCheckLine, clDefCheckLine)
    If mlCheckLine < clDefCheckLine Then
        mlCheckLine = clDefCheckLine
    End If
    mbCodeChange = GetSetting(csCompany, lsProductName, csCodeChange, True)
    mbSmallize = GetSetting(csCompany, lsProductName, csSmallize, False)
    mbIgnoreIndex = GetSetting(csCompany, lsProductName, csIgnoreIndex, True)
    mbIgnoreQuestion = GetSetting(csCompany, lsProductName, csIgnoreQuestion, True)
    mbIgnoreSharp = GetSetting(csCompany, lsProductName, csIgnoreSharp, True)
    mbIgnorePortNo = GetSetting(csCompany, lsProductName, csIgnorePortNo, True)
    mbSpecifyHost = GetSetting(csCompany, lsProductName, csSpecifyHost, False)
    mbIgnoreHost = GetSetting(csCompany, lsProductName, csIgnoreHost, False)
    mbIgnorePage = GetSetting(csCompany, lsProductName, csIgnorePage, True)
    mbSearchLike = GetSetting(csCompany, lsProductName, csSearchLike, False)
    mbAutoFtp = GetSetting(csCompany, lsProductName, csAutoFtp, False)
    mbAutoAnalize = GetSetting(csCompany, lsProductName, csAutoAnalize, False)
    mbAutoMaxSize = GetSetting(csCompany, lsProductName, csAutoMaxSize, False)
    mbAutoTile = GetSetting(csCompany, lsProductName, csAutoTile, False)

    msFtpServerName = GetSetting(csCompany, lsProductName, csFtpServerName)
    msFtpUserName = GetSetting(csCompany, lsProductName, csFtpUserName)
    msFtpPassword = GetSetting(csCompany, lsProductName, csFtpPassword)
    If Len(msFtpPassword) = 60 Then
        msFtpPassword = aaDecPassword(msFtpPassword)
        If msFtpPassword <> "" Then
            mbFtpSavePasswd = True
        Else
            mbFtpSavePasswd = False
        End If
    Else
        msFtpPassword = ""
        mbFtpSavePasswd = False
    End If
    mbFtpOverwrite = GetSetting(csCompany, lsProductName, csFtpOverwrite, True)
    mbFtpMessage = GetSetting(csCompany, lsProductName, csFtpMessage, True)
    msFtpHostDir = GetSetting(csCompany, lsProductName, csFtpHostDir, csDefFtpHostDir)
    msFtpLocalDir = GetSetting(csCompany, lsProductName, csFtpLocalDir, App.Path)
    msFtpFileName = GetSetting(csCompany, lsProductName, csFtpFileName, csDefLogFileName)

    lsColorValue = GetSetting(csCompany, lsProductName, csGraphFore)
    If Len(lsColorValue) = 9 Then
        msGraphFore = Trim(lsColorValue)
    Else
        msGraphFore = csDefGraphFore
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphBack)
    If Len(lsColorValue) = 9 Then
        msGraphBack = Trim(lsColorValue)
    Else
        msGraphBack = csDefGraphBack
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphMonth)
    If Len(lsColorValue) = 9 Then
        msGraphMonth = Trim(lsColorValue)
    Else
        msGraphMonth = csDefGraphMonth
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphWWeek)
    If Len(lsColorValue) = 9 Then
        msGraphWWeek = Trim(lsColorValue)
    Else
        msGraphWWeek = csDefGraphWWeek
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphDWeek)
    If Len(lsColorValue) = 9 Then
        msGraphDWeek = Trim(lsColorValue)
    Else
        msGraphDWeek = csDefGraphDWeek
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphDate)
    If Len(lsColorValue) = 9 Then
        msGraphDate = Trim(lsColorValue)
    Else
        msGraphDate = csDefGraphDate
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphTime)
    If Len(lsColorValue) = 9 Then
        msGraphTime = Trim(lsColorValue)
    Else
        msGraphTime = csDefGraphTime
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphOS)
    If Len(lsColorValue) = 9 Then
        msGraphOS = Trim(lsColorValue)
    Else
        msGraphOS = csDefGraphOS
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphBrws)
    If Len(lsColorValue) = 9 Then
        msGraphBrws = Trim(lsColorValue)
    Else
        msGraphBrws = csDefGraphBrws
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphHost)
    If Len(lsColorValue) = 9 Then
        msGraphHost = Trim(lsColorValue)
    Else
        msGraphHost = csDefGraphHost
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphRef)
    If Len(lsColorValue) = 9 Then
        msGraphRef = Trim(lsColorValue)
    Else
        msGraphRef = csDefGraphRef
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphPage)
    If Len(lsColorValue) = 9 Then
        msGraphPage = Trim(lsColorValue)
    Else
        msGraphPage = csDefGraphPage
    End If
    lsColorValue = GetSetting(csCompany, lsProductName, csGraphAgent)
    If Len(lsColorValue) = 9 Then
        msGraphAgent = Trim(lsColorValue)
    Else
        msGraphAgent = csDefGraphAgent
    End If

    msFontName = GetSetting(csCompany, lsProductName, csFontName, csDefFontName)
    miFontSize = GetSetting(csCompany, lsProductName, csFontSize, ciDefFontSize)

    miGraphPattern = GetSetting(csCompany, lsProductName, csGraphPattern, ciDefGraphPattern)

    miPrintWindow = GetSetting(csCompany, lsProductName, csPrintWindow, ciDefVisWindow)
    miPaperType = GetSetting(csCompany, lsProductName, csPaperType, 0)
End Function

Public Function aaWriteIniRegs() As Boolean
'---------------------------------------------------------------------------
'    : aaWriteIniRegs()
' @@@\ : ݒt@C̏
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2000/02/25
'---------------------------------------------------------------------------
    Dim liRetCode       As Integer          ' ߂l
    Dim lsProductName   As String           ' v_Ng
    Dim liLoopCnt       As Integer          ' [vJE^

    On Error GoTo aaWriteIniRegs_Error
    lsProductName = App.ProductName

    SaveSetting csCompany, lsProductName, csRegistrant, msRegistrant
    SaveSetting csCompany, lsProductName, csRegistKey, msRegistKey

    SaveSetting csCompany, lsProductName, csMainWidth, mlMainWidth
    SaveSetting csCompany, lsProductName, csMainHeight, mlMainHeight
    SaveSetting csCompany, lsProductName, csVisibleWindow, miVisibleWindow
    SaveSetting csCompany, lsProductName, csMainToolbar, mbMainToolbar

    For liLoopCnt = 1 To ciDefMaxLogFile
        SaveSetting csCompany, lsProductName, csLogFile & liLoopCnt, msLogFile(liLoopCnt)
    Next liLoopCnt
    For liLoopCnt = 1 To ciDefMaxPage
        SaveSetting csCompany, lsProductName, csPage & liLoopCnt, msPage(liLoopCnt)
    Next liLoopCnt
    SaveSetting csCompany, lsProductName, csSpecifyDate, mbSpecifyDate
    SaveSetting csCompany, lsProductName, csStartDate, Format(mdStartDate, "yyyy/m/d")
    SaveSetting csCompany, lsProductName, csEndDate, Format(mdEndDate, "yyyy/m/d")
    SaveSetting csCompany, lsProductName, csSpecifyPage, mbSpecifyPage

    SaveSetting csCompany, lsProductName, csMaxDisp, miMaxDisp
    SaveSetting csCompany, lsProductName, csIgnoreIp, mbIgnoreIp
    SaveSetting csCompany, lsProductName, csSpecifyClass, mbSpecifyClass
'    SaveSetting csCompany, lsProductName, csCheckLine, mlCheckLine
    SaveSetting csCompany, lsProductName, csCodeChange, mbCodeChange
    SaveSetting csCompany, lsProductName, csSmallize, mbSmallize
    SaveSetting csCompany, lsProductName, csIgnoreIndex, mbIgnoreIndex
    SaveSetting csCompany, lsProductName, csIgnoreQuestion, mbIgnoreQuestion
    SaveSetting csCompany, lsProductName, csIgnoreSharp, mbIgnoreSharp
    SaveSetting csCompany, lsProductName, csIgnorePortNo, mbIgnorePortNo
    SaveSetting csCompany, lsProductName, csSpecifyHost, mbSpecifyHost
    SaveSetting csCompany, lsProductName, csIgnoreHost, mbIgnoreHost
    SaveSetting csCompany, lsProductName, csIgnorePage, mbIgnorePage
    SaveSetting csCompany, lsProductName, csSearchLike, mbSearchLike
    SaveSetting csCompany, lsProductName, csAutoFtp, mbAutoFtp
    SaveSetting csCompany, lsProductName, csAutoAnalize, mbAutoAnalize
    SaveSetting csCompany, lsProductName, csAutoMaxSize, mbAutoMaxSize
    SaveSetting csCompany, lsProductName, csAutoTile, mbAutoTile

    SaveSetting csCompany, lsProductName, csFtpServerName, msFtpServerName
    SaveSetting csCompany, lsProductName, csFtpUserName, msFtpUserName
    If mbFtpSavePasswd <> False Then
        SaveSetting csCompany, lsProductName, csFtpPassword, aaEncPassword(msFtpPassword)
    Else
        SaveSetting csCompany, lsProductName, csFtpPassword, aaEncPassword(msFtpPassword)
        DeleteSetting csCompany, lsProductName, csFtpPassword
    End If
    SaveSetting csCompany, lsProductName, csFtpOverwrite, mbFtpOverwrite
    SaveSetting csCompany, lsProductName, csFtpMessage, mbFtpMessage
    SaveSetting csCompany, lsProductName, csFtpHostDir, msFtpHostDir
    SaveSetting csCompany, lsProductName, csFtpLocalDir, msFtpLocalDir
    SaveSetting csCompany, lsProductName, csFtpFileName, msFtpFileName

    SaveSetting csCompany, lsProductName, csGraphFore, msGraphFore
    SaveSetting csCompany, lsProductName, csGraphBack, msGraphBack
    SaveSetting csCompany, lsProductName, csGraphMonth, msGraphMonth
    SaveSetting csCompany, lsProductName, csGraphWWeek, msGraphWWeek
    SaveSetting csCompany, lsProductName, csGraphDWeek, msGraphDWeek
    SaveSetting csCompany, lsProductName, csGraphDate, msGraphDate
    SaveSetting csCompany, lsProductName, csGraphTime, msGraphTime
    SaveSetting csCompany, lsProductName, csGraphOS, msGraphOS
    SaveSetting csCompany, lsProductName, csGraphBrws, msGraphBrws
    SaveSetting csCompany, lsProductName, csGraphHost, msGraphHost
    SaveSetting csCompany, lsProductName, csGraphRef, msGraphRef
    SaveSetting csCompany, lsProductName, csGraphPage, msGraphPage
    SaveSetting csCompany, lsProductName, csGraphAgent, msGraphAgent

    SaveSetting csCompany, lsProductName, csFontName, msFontName
    SaveSetting csCompany, lsProductName, csFontSize, miFontSize

    SaveSetting csCompany, lsProductName, csGraphPattern, miGraphPattern

    SaveSetting csCompany, lsProductName, csPrintWindow, miPrintWindow
    SaveSetting csCompany, lsProductName, csPaperType, miPaperType

    aaWriteIniRegs = True
    Exit Function

aaWriteIniRegs_Error:
    liRetCode = MsgBox("WXg݂̏Ɏs܂B", vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    aaWriteIniRegs = False
End Function

Private Function aaEncPassword(ByVal psPassword As String) As String
'---------------------------------------------------------------------------
'    : aaEncPassword()
' @@@\ : Í
' @@ : (I) psPassword     Í镶
'   l : Í
' @@ : 2000/01/15
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer          ' [vJE^
    Dim liKeyWord       As Integer          ' L[[h
    Dim liPassLen       As Integer          ' pX[h
    Dim llTotal         As Long             ' `FbNp
    Dim lsWord          As String           ' P̒l
    Dim lsPassword      As String           ' pX[h
    Dim lsXorString     As String           ' Íp

    On Error GoTo aaEncPassword_Error

    liKeyWord = Int((Rnd * 155) + 100)
    liPassLen = Len(psPassword)
    lsPassword = Int((Rnd * 15) + 10) & liKeyWord & Int(Rnd * 10) & Format((liPassLen Mod liKeyWord), "000")
    lsXorString = App.LegalCopyright

    For liLoopCnt = 1 To liPassLen
        lsWord = (Asc(Mid$(psPassword, liLoopCnt, 1)) Xor liKeyWord) Xor Asc(Mid$(lsXorString, liLoopCnt, 1))
        lsPassword = lsPassword & Format(lsWord, "000")
        llTotal = llTotal + CLng(lsWord)
    Next liLoopCnt

    For liLoopCnt = liLoopCnt To 16
        lsWord = Int((Rnd * 155) + 100) Xor liKeyWord
        lsPassword = lsPassword & Format(lsWord, "000")
        llTotal = llTotal + CLng(lsWord)
    Next liLoopCnt

    aaEncPassword = lsPassword & Format((llTotal Mod 255), "000")
    Exit Function

aaEncPassword_Error:
    aaEncPassword = ""
End Function

Private Function aaDecPassword(ByVal psPassword As String) As String
'---------------------------------------------------------------------------
'    : aaDecPassword()
' @@@\ : 
' @@ : (I) psPassword     镶
'   l : 
' @@ : 2000/01/15
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer          ' [vJE^
    Dim liKeyWord       As Integer          ' L[[h
    Dim liPassLen       As Integer          ' pX[h
    Dim llTotal         As Long             ' `FbNp
    Dim lsWord          As String           ' P̒l
    Dim lsPassword      As String           ' pX[h
    Dim lsXorString     As String           ' Íp

    On Error GoTo aaDecPassword_Error

    liKeyWord = Mid(psPassword, 3, 3)
    liPassLen = Mid(psPassword, 7, 3)
    lsXorString = App.LegalCopyright

    For liLoopCnt = 1 To liPassLen
        lsWord = Mid$(psPassword, 7 + liLoopCnt * 3, 3)
        llTotal = llTotal + CLng(lsWord)
        lsPassword = lsPassword & Chr((lsWord Xor Asc(Mid$(lsXorString, liLoopCnt, 1))) Xor liKeyWord)
    Next liLoopCnt

    For liLoopCnt = liLoopCnt To 16
        lsWord = Mid$(psPassword, 7 + liLoopCnt * 3, 3)
        llTotal = llTotal + CLng(lsWord)
    Next liLoopCnt

    lsWord = Right$(psPassword, 3)
    If CLng(lsWord) <> (llTotal Mod 255) Then
        lsPassword = ""
    End If

    aaDecPassword = lsPassword
    Exit Function

aaDecPassword_Error:
    aaDecPassword = ""
End Function
