// acalz.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include "tchar.h"

#include "acalz.h"
#pragma comment(linker,"/DEFAULTLIB:version.lib")

static char		mDllName[200];

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }

	GetModuleFileName((HINSTANCE)hModule, mDllName, sizeof(mDllName));

    return TRUE;
}

ACALZ_DLL_API int __stdcall aa_get_version(char *cur_ver)
{
	void		*m_pBlock;
	VS_FIXEDFILEINFO	*m_pFixedFileInfo;
	UINT		tmp;
	DWORD		dwSize=::GetFileVersionInfoSize((LPTSTR)mDllName, NULL);

	m_pBlock = new char[dwSize];
	GetFileVersionInfo((LPTSTR)mDllName, NULL, dwSize, m_pBlock);
	VerQueryValue(m_pBlock, _T("\\"), (void**)&m_pFixedFileInfo, &tmp);
	sprintf(cur_ver, "%d.%02d", HIWORD(m_pFixedFileInfo->dwFileVersionMS),LOWORD(m_pFixedFileInfo->dwFileVersionMS));
	cur_ver[strlen(cur_ver)] = ' '; // VB
	delete [] m_pBlock;

	return 1;
}

ACALZ_DLL_API int __stdcall aa_get_analize_line(char *fname, int maxBuf)
{
	int			readLine = 0;
	int			readByte;
	int			alcSize;
	char		*readBuf;
	char		*srchPtr;
	char		*lfPtr;
	char		*tabPtr;
	FILE		*fp;

	alcSize = maxBuf;
	readBuf = NULL;
	while ((!readBuf) && (alcSize > 0)) {
		readBuf = (char *)calloc(sizeof(char), alcSize);
		alcSize = alcSize / 2;
	}

	if (readBuf) {
		fp = fopen(fname, "rb");
		if (fp) {
			while (!feof(fp)) {
				readByte = fread(readBuf, sizeof(char), alcSize, fp);
				if (readByte != alcSize) {
					memset(&readBuf[readByte], 0, (alcSize - readByte));
				}
				srchPtr = readBuf;
				while (srchPtr) {
					lfPtr = strchr(srchPtr, 0x0a);
					tabPtr = strchr(srchPtr, 0x09);
					if ((lfPtr != NULL) || (tabPtr != NULL)) {
						if (lfPtr > tabPtr) {
							if (tabPtr != NULL) {
								srchPtr = tabPtr + 1;
							}
							else {
								srchPtr = lfPtr + 1;
							}
						}
						else {
							if (lfPtr != NULL) {
								srchPtr = lfPtr + 1;
							}
							else {
								srchPtr = tabPtr + 1;
							}
						}
						readLine++;
					}
					else {
						srchPtr = NULL;
					}
				}
			}
			fclose(fp);
		}
		free(readBuf);
	}

	return readLine;
}

ACALZ_DLL_API int __stdcall aa_check_date(long *month_acc, long *wweek_acc, long *dweek_acc, long *days_acc, long *hour_acc, char *check_line, char *start_str, char *end_str, int date_check)
{
	int				ret_code = 0;
	int				year_value;			// N
	int				month_value;		// 
	int				day_value;			// 
	int				hour_value;			// 
	time_t			log_date;			// O̓t
	struct tm		log_sdate;			// O̓t
	time_t			start_date;			// ͊Jnt
	time_t			end_date;			// ͏It
	time_t			nyear_date;			// ͔N̂PP
	struct tm		nyear_sdate;		// ͔N̂PP
	int				week_year;			// PN̏T
	char			*work_ptr;			// Ɨp|C^

	// t^ԉ
	if (date_check != 0) {
		work_ptr = start_str;
		year_value = atoi(work_ptr);
		work_ptr = strchr(work_ptr, '/') + 1;
		month_value = atoi(work_ptr) - 1;
		work_ptr = strchr(work_ptr, '/') + 1;
		day_value = atoi(work_ptr);
		memset(&log_sdate, 0, sizeof(struct tm));
		log_sdate.tm_year = year_value - 1900;
		log_sdate.tm_mon = month_value;
		log_sdate.tm_mday = day_value;
		start_date = mktime(&log_sdate);

		work_ptr = end_str;
		year_value = atoi(work_ptr);
		work_ptr = strchr(work_ptr, '/') + 1;
		month_value = atoi(work_ptr) - 1;
		work_ptr = strchr(work_ptr, '/') + 1;
		day_value = atoi(work_ptr);
		memset(&log_sdate, 0, sizeof(struct tm));
		log_sdate.tm_year = year_value - 1900;
		log_sdate.tm_mon = month_value;
		log_sdate.tm_mday = day_value;
		end_date = mktime(&log_sdate);
	}

	work_ptr = strchr(check_line, ')') + 1;
	year_value = atoi(work_ptr);
	work_ptr = strchr(work_ptr, '/') + 1;
	month_value = atoi(work_ptr) - 1;
	work_ptr = strchr(work_ptr, '/') + 1;
	day_value = atoi(work_ptr);
	work_ptr = strchr(work_ptr, ' ') + 1;
	hour_value = atoi(work_ptr);
	memset(&log_sdate, 0, sizeof(struct tm));
	log_sdate.tm_year = year_value - 1900;
	log_sdate.tm_mon = month_value;
	log_sdate.tm_mday = day_value;
	log_date = mktime(&log_sdate);
	memcpy(&log_sdate, localtime(&log_date), sizeof(struct tm));

	if ((date_check == 0) || ((start_date <= log_date) && (log_date <= end_date))) {
		memset(&nyear_sdate, 0, sizeof(struct tm));
		nyear_sdate.tm_year = log_sdate.tm_year;
		nyear_sdate.tm_mon = 0;
		nyear_sdate.tm_mday = 1;
		nyear_date = mktime(&nyear_sdate);
		memcpy(&nyear_sdate,
			localtime(&nyear_date), sizeof(struct tm));
		week_year = (log_sdate.tm_yday + nyear_sdate.tm_wday) / 7;

		*month_acc = month_value + 1;
		*wweek_acc = week_year + 1;
		*dweek_acc = log_sdate.tm_wday + 1;
		*days_acc = day_value;
		*hour_acc = hour_value;
		ret_code = 1;
	}

	return ret_code;
}

// ̓GNX|[gꂽNX̃RXgN^łB
// NX̒`ɂĂ acalz.h QƂĂB
CAcalz::CAcalz()
{ 
	return; 
}

